<?php
/*
=====================================================
 DataLife Engine - by SoftNews Media Group
-----------------------------------------------------
 http://dle-news.ru/
-----------------------------------------------------
 Copyright (c) 2004-2017 SoftNews Media Group
=====================================================
 Данный код защищен авторскими правами
=====================================================
 Файл: install.php
-----------------------------------------------------
 Назначение: Установка скрипта
=====================================================
*/
session_start();

@error_reporting ( E_ALL ^ E_WARNING ^ E_NOTICE );
@ini_set ( 'display_errors', true );
@ini_set ( 'html_errors', false );
@ini_set ( 'error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE );

define('DATALIFEENGINE', true);
define('ROOT_DIR', dirname (__FILE__));
define('ENGINE_DIR', ROOT_DIR.'/engine');

$distr_charset = "utf-8";
$db_charset = "utf8";

header("Content-type: text/html; charset=".$distr_charset);

require_once(ROOT_DIR.'/language/Russian/adminpanel.lng');
require_once(ENGINE_DIR.'/inc/include/functions.inc.php');


$skin_header = <<<HTML
<!doctype html>
<html>
<head>
	<meta charset="{$distr_charset}">
	<title>DataLife Engine - Установка</title>
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<meta name="HandheldFriendly" content="true">
	<meta name="format-detection" content="telephone=no">
	<meta name="viewport" content="user-scalable=no, initial-scale=1.0, maximum-scale=1.0, width=device-width"> 
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-status-bar-style" content="default">
    <link href="engine/skins/fonts/fontawesome/styles.min.css" media="screen" rel="stylesheet" type="text/css" />
    <link href="engine/skins/stylesheets/application.css" media="screen" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="engine/skins/javascripts/application.js"></script>
</head>
<body class="no-theme">
<script language="javascript" type="text/javascript">
<!--
var dle_act_lang   = [];
var cal_language   = {en:{months:[],dayOfWeek:[]}};
var filedefaulttext= '';
var filebtntext    = '';
//-->
</script>
<div class="navbar navbar-inverse bg-primary-700">
	<div class="navbar-header">
		<a class="navbar-brand" href="#">Мастер установки DataLife Engine «Seopirat»</a>
	</div>
</div>
<div class="page-container">
	<div class="page-content">
		<div class="col-md-8 col-md-offset-2 mt-20">
<!--MAIN area-->

HTML;


$skin_footer = <<<HTML
	 <!--MAIN area-->
    </div>
  </div>
</div>
</body>
</html>
HTML;

function msgbox($type, $title, $text, $back=false){
global $lang, $skin_header, $skin_footer;

  if ($back) $back = "onclick=\"history.go(-1); return false;\""; else $back = "";

  echo $skin_header;

echo <<<HTML
<form action="install.php" method="get">
<div class="panel panel-default">
  <div class="panel-heading">
	{$title}
  </div>
  <div class="panel-body">
		{$text}
  </div>
  <div class="panel-footer">
	<button type="submit" {$back} class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>
</div>
</form>
HTML;

  echo $skin_footer;

  exit();
}

function GetRandInt($max){

	if(function_exists('openssl_random_pseudo_bytes')) {
	     do{
	         $result = floor($max*(hexdec(bin2hex(openssl_random_pseudo_bytes(4)))/0xffffffff));
	     }while($result == $max);
	} else {

		$result = mt_rand( 0, $max );
	}

    return $result;
}

function generate_auth_key() {

    $arr = array('a','b','c','d','e','f',
                 'g','h','i','j','k','l',
                 'm','n','o','p','r','s',
                 't','u','v','x','y','z',
                 'A','B','C','D','E','F',
                 'G','H','I','J','K','L',
                 'M','N','O','P','R','S',
                 'T','U','V','X','Y','Z',
                 '1','2','3','4','5','6',
                 '7','8','9','0','.',',',
                 '(',')','[',']','!','?',
                 '&','^','%','@','*',' ',
                 '<','>','/','|','+','-',
                 '{','}','`','~','#',';',
                 '/','|','=',':','`');

    $key = "";
    for($i = 0; $i < 64; $i++)
    {
      $index = GetRandInt(count($arr))-1;
      $key .= $arr[$index];
    }
    return $key;
}

if($_REQUEST['action'] == "eula") {

  if ( !$_SESSION['dle_install'] ) msgbox( "", "Ошибка", "Установка скрипта была начата не с начала. Вернитесь на главную страницу начала установки скрипта: <br /><br /><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a>" );

  echo $skin_header;

echo <<<HTML
<form id="check-eula" method="get" action="">
<input type=hidden name=action value="function_check">
<script language='javascript'>
function check_eula(){

	if( document.getElementById( 'eula' ).checked == true )
	{
		return true;
	}
	else
	{
		DLEalert( 'Вы должны принять лицензионное соглашение, прежде чем продолжите установку.', 'Информация' );
		return false;
	}
};
document.getElementById( 'check-eula' ).onsubmit = check_eula;
</script>
<div class="panel panel-default">
  <div class="panel-heading">
    Лицензионное соглашение
  </div>
  <div class="panel-body">
		Пожалуйста, внимательно прочитайте и примите пользовательское соглашение по использованию DataLife Engine.<br /><br /><div style="height: 300px; border: 1px solid #76774C; background-color: #FDFDD3; padding: 5px; overflow: auto;"><div style="text-align:center;"><b>Пользовательское лицензионное соглашение на использование программы для ЭВМ "DataLife Engine"</b></div><br /><!--colorstart:#FF0000--><span style="color:#FF0000"><!--/colorstart-->Уважаемый Пользователь! Перед началом установки, копирования либо иного использования Программы внимательно ознакомьтесь с условиями ее использования, содержащимися в настоящем Соглашении. Установка, запуск или иное начало использования Программы означает надлежащее заключение настоящего Соглашения и Ваше полное согласие со всеми его условиями. Если Вы не согласны безоговорочно принять условия настоящего Соглашения, Вы не имеете права устанавливать и использовать Программу и должны удалить все ее компоненты со своего компьютера (ЭВМ).<!--colorend--></span><!--/colorend--><br /><br />Настоящее лицензионное соглашение (далее – Соглашение) заключается между ООО «СофтНьюс Медиа Групп» (далее – Лицензиат) и любым физическим лицом, индивидуальным предпринимателем, юридическим лицом (далее – Пользователь).<br /><br /><div style="text-align:center;"><b>1. Основные термины</b></div><br /><b>1.1.</b> <b>Программа</b> – программа для ЭВМ "DataLife Engine", соответствующей версии (как в целом, так и ее компоненты), являющаяся представленной в объективной форме совокупностью данных и команд, в том числе, исходного текста, базы данных, аудиовизуальных произведений, включенных Лицензиатом в состав указанной программы для ЭВМ, а также любая документация по её использованию.<br /><br /><b>1.2. Использование программы</b> - любые действия, связанные с функционированием Программы в соответствии с ее назначением (в том числе запись в память ЭВМ).<br /><br /><b>1.3. Техническая поддержка</b> – мероприятия, осуществляемые Лицензиатом в установленных им пределах и объемах для обеспечения функционирования Программы, включая информационно-консультационную поддержку Пользователей по вопросам использования Программы.<br /><br /><b>1.4. Лицензиар</b> - собственник, владелец и правообладатель Программы, выдающий, другому лицу (Лицензиату) лицензию, предоставляющую право использования Программы в установленных Лицензионным договором пределах.<br /><br /><b>1.5. Лицензиат</b> - юридическое лицо или индивидуальный предприниматель, имеющие лицензию, в настоящем соглашении ООО «СофтНьюс Медиа Групп».<br /><br /><b>1.6. Пользователь</b> - физическое или юридическое лицо, или индивидуальный предприниматель, приобретающий лицензию на право использования DataLife Engine по данному лицензионному соглашению.<br /><br /><div style="text-align:center;"><b>2. Предмет лицензионного соглашения</b></div><br /><b>2.1.</b> Предметом настоящего лицензионного соглашения является право использования одной лицензионной копии программы для ЭВМ "DataLife Engine", в порядке и на условиях, установленных настоящим соглашением. Если вы не согласны с условиями данного соглашения, вы не можете использовать данный продукт. Установка и использование продукта означает ваше полное согласие со всеми пунктами настоящего соглашения.<br /><br /><b>2.2.</b> Все положения настоящего Соглашение распространяется как на Программу в целом, так и на её отдельные компоненты, за исключением случаев, когда для компонента системы применяется другой тип лицензии.<br /><br /><b>2.3.</b> Настоящее Соглашение заключается до или непосредственно в момент начала использования Программы и действует на протяжении всего срока ее правомерного использования Пользователем в пределах срока действия авторского права на нее при условии надлежащего соблюдения Пользователем условий настоящего Соглашения.<br /><br /><div style="text-align:center;"><b>3. Содержание договора</b></div><br /><b>3.1. </b>Срок обслуживания клиента с момента приобретения одной лицензионной копии Программы "DataLife Engine" равен одному году. Если по истечении срока обслуживания, Вы решите не продлевать его действие, то Ваша Программа будет функционировать в полном объеме, но без нашей технической поддержки и без предоставления новых версий Программы, за исключением критических обновлений Программы.<br /><br /><b>3.2. </b>Лицензиат осуществляет Техническую поддержку Пользователя, в том числе по вопросам, связанным с функциональностью, особенностями установки и эксплуатации на стандартных конфигурациях поддерживаемых (популярных) операционных, почтовых и иных систем Программы в порядке и на условиях, указанных в технической документации к ней.<br /><br /><b>3.3. </b>В случае приобретения и использования только базовой лицензии на Программу, обслуживание клиентов, на время действия лицензионного соглашения, ограничивается только предоставлением стандартных услуг по обслуживанию: предоставление дистрибутивов, новых версий Программы, критических обновлений Программы. Технической поддержки по базовым лицензиям не предоставляется. Для получения технической поддержки по Программе, пользователям необходимо иметь лицензию, включающую в себя службу технической поддержки, либо быть подписчиком на службу технической поддержки.<br /><br /><b>3.4. </b>В случае приобретения Пользователем Программы для передачи непосредственным заказчикам уже готового сайта или проекта, Пользователь обязан уведомить заказчика о настоящем лицензионном соглашении, а также полностью передать ему свой клиентский доступ на сайте dle-news.ru, в противном случае, Пользователем лицензии остается лицо непосредственно оплатившее лицензию, и имеющие клиентский доступ на сайте dle-news.ru. Третьим лицам, не имеющим данного доступа, в поддержке и предоставлению дистрибутивов будет отказано.<br /><br /><b>3.5. </b>Мы оставляем за собой право публиковать, с согласия пользователя программного продукта, списки избранных сайтов, на которых используется Программа "DataLife Engine". Мы оставляем за собой право в любое время изменять условия данного договора, но данные изменения не имеют обратной силы. Изменения данного договора будут разосланы пользователям по электронной почте на адреса, указанные при приобретении лицензии на Программу.<br /><br /><div style="text-align:center;"><b>4. Ограничения использования Программы</b></div><br /><b>4.1. </b>Программа является результатом интеллектуальной деятельности и объектом авторских прав (программа для ЭВМ), которые регулируются и защищены законодательством Российской Федерации об интеллектуальной собственности и нормами международного права.<br /><br /><b>4.2. </b>Название "DataLife Engine", а также входящие в данную Программу скрипты являются собственностью Лицензиара, использование которых возможно только в рамках данного соглашения, за исключением случаев, когда для компонента системы применяется другой тип лицензии. Любые публикуемые оригинальные материалы, создаваемые в результате использования нашей Программы, и связанные с этим права на них, являются собственностью пользователя и защищены законом. Лицензиар и Лицензиат не несут никакой ответственности за содержание сайтов, создаваемых пользователем Программы "DataLife Engine".<br /><br /><b>4.3. </b>Алгоритм работы Программы и ее исходные коды (в том числе их части) являются собственностью Лицензиара и Лицензиата. Любое их использование или использование Программы в нарушение условий настоящего Соглашения рассматривается как нарушение прав Лицензиара и является достаточным основанием для лишения Пользователя предоставленных по настоящему Соглашению прав.<br /><br /><b>4.4. </b>Лицензиат гарантирует, что обладает всеми необходимыми по настоящему Соглашению правами для предоставления их Пользователю, включая документацию к Программе.<br /><br /><b>4.5. </b>Приобретая лицензию на Программу "DataLife Engine", вы должны знать, что не приобретаете авторские права на Программу. Вы приобретаете только право на использование Программы на единственном веб сайте (одном домене второго уровня и его поддоменах), принадлежащем Вам или Вашему клиенту. Для использования Программы на другом сайте, вам необходимо приобретать повторную лицензию.<br /><br /><b>4.6. </b>Запрещается перепродажа Программы третьим лицам.<br /><br /><b>4.7. </b>Настоящим соглашением Пользователю не предоставляются никакие права на использование товарных знаков и знаков обслуживания Лицензиара, и Лицензиата.<br /><br /><b>4.8. </b>Пользователь не может ни при каких условиях удалять или изменять вид информации и сведения об авторских правах, правах на товарные знаки или патенты, указанные в исходном коде Программы.<br /><br /><div style="text-align:center;"><b>5. Права и обязанности сторон</b></div><br /><b>5.1. Пользователь имеет право:</b><br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.1.1 </b>Изменять дизайн и структуру программного кода в соответствии с нуждами своего сайта.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.1.2 </b>Производить и распространять инструкции по созданным собственных модификациям шаблонов и языковых файлов, если в них будет иметься указание на оригинального разработчика программного продукта до Ваших модификаций. Модификации, произведенные Вами самостоятельно, не являются собственностью Лицензиара, если не содержат программные коды непосредственно Программы.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.1.3 </b>Создавать дополнительные собственные модули для Программы, которые будут взаимодействовать с программными кодами Программы, с указанием на то, что это оригинальный продукт Пользователя.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.1.4 </b>Переносить Программу на другой сайт после обязательного уведомления об этом Лицензиата, а также полного удаления Программы с предыдущего сайта.<br /><br /><b>5.2. Пользователь не имеет право:</b><br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.1</b> Передавать права на использование Программы  третьим лицам.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.2 </b>Использовать или изменять структуру программных кодов, функции программы, с целью создания родственных продуктов.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.3 </b>Создавать отдельные самостоятельные продукты, базирующиеся на нашем программном коде.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.4 </b>Использовать копии Программы "DataLife Engine" по одной лицензии на более чем одном сайте (одном домене второго уровня и его поддоменах).<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.5 </b>Рекламировать, продавать или публиковать на своем сайте пиратские копии Программы.<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.6 </b>Использовать, распространять нелицензионные копии Программы "DataLife Engine" или содействовать распространению нелицензионных копий Программы "DataLife Engine".<br /><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>5.2.7 </b>Модифицировать и удалять механизмы проверки наличия оригинальной лицензии на использование Программы.<br /><br /><div style="text-align:center;"><b>6. Ограничение гарантийных обязательств</b></div><br /><b>6.1. </b>Мы хотим отметить, что механизмы безопасности, установленные на "DataLife Engine", имеют известные ограничения, и несмотря на то, что мы прилагаем максимальные усилия по обеспечению безопасности Программы, вы должны быть ознакомлены с отсутствием абсолютных гарантий от взлома вашего сайта. Так же наши гарантии и техническая поддержка не распространяются на модификации, произведенные третьей стороной, включая изменения программного кода, стиля, языковых пакетов, а также на изменения перечисленных частей, внесенные владельцем лицензии самостоятельно. Если Программа изменена Вами или третьей стороной, то мы вправе отказать Вам в технической поддержке.<br /><br /><b>6.2. </b>Программа "DataLife Engine" не подлежит возврату или обмену из-за отсутствия гарантий защищающих Программу от копирования.<br /><br /><div style="text-align:center;"><b>7. Досрочное расторжение договорных обязательств</b></div><br /><b>7.1. </b>Данное соглашение расторгается автоматически, если Вы отказываетесь выполнять условия нашего соглашения. Данное сублицензионное соглашение может быть расторгнуто нами в одностороннем порядке, в случае установления фактов нарушения данного сублицензионного соглашения. В случае досрочного расторжения соглашения Вы обязуетесь удалить все Ваши копии нашей Программы в течении 3 рабочих дней, с момента получения соответствующего уведомления.</div>
		<div class="checkbox"><label><input type="checkbox" name="eula" id="eula" class="icheck">Я принимаю данное соглашение</label></div>
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>
</div>
</form>
HTML;

} elseif($_REQUEST['action'] == "function_check") {

    if ( !$_SESSION['dle_install'] ) msgbox( "", "Ошибка", "Установка скрипта была начата не с начала. Вернитесь на главную страницу начала установки скрипта: <br /><br /><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a>" );

  echo $skin_header;

echo <<<HTML
<form method="get" action="">
<input type=hidden name="action" value="chmod_check">
<div class="panel panel-default">
  <div class="panel-heading">
    Проверка установленных компонентов PHP
  </div>
  <div class="table-responsive">
<table class="table table-striped table-xs">
<thead>
<th width="300">Минимальные требования скрипта</th>
<th colspan="2">Текущее значение</th>
</thead>
HTML;


	if( version_compare(phpversion(), '5.3.7', '<') ) {
		 $status = '<span class="text-danger"><b>Нет</b></span>';
	} else {
		$status = '<span class="text-success"><b>Да</b></span>';
    }
	
   echo "<tr>
         <td>Версия PHP 5.3.7 и выше</td>
         <td colspan=2>$status</td>
         </tr>";

    $status = function_exists('mysqli_connect') ? '<span class="text-success"><b>Да</b></span>' : '<span class="text-danger"><b>Нет</b></span>';

   echo "<tr>
         <td>Поддержка MySQLi</td>
         <td colspan=2>$status</td>
         </tr>";


    $status = extension_loaded('zlib') ? '<span class="text-success"><b>Да</b></span>' : '<span class="text-danger"><b>Нет</b></span>';

   echo "<tr>
         <td>Поддержка сжатия ZLib</td>
         <td colspan=2>$status</td>
         </tr>";

    $status = extension_loaded('xml') ? '<span class="text-success"><b>Да</b></span>' : '<span class="text-danger">><b>Нет</b></span>';

   echo "<tr>
         <td>Поддержка XML</td>
         <td colspan=2>$status</td>
         </tr>";

    $status = function_exists('mb_convert_encoding') ? '<span class="text-success"><b>Да</b></span>' : '<span class="text-danger"><b>Нет</b></span>';

   echo "<tr>
         <td>Поддержка многобайтных строк</td>
         <td colspan=2>$status</td>
         </tr>";

    #ionCube check [Seopirat]
    $status = extension_loaded('ionCube Loader') ? '<span class="text-success"><b>Да</b></span>' : '<span class="text-danger"><b>Нет</b></span>';

   echo "<tr>
         <td>Расширение php ionCube Loader</td>
         <td colspan=2>$status</td>
         </tr>";

echo <<<HTML
</table>
  <div class="panel-body">
	Если любой из этих пунктов выделен красным, то пожалуйста выполните действия для исправления положения. В случае несоблюдения минимальных требований скрипта возможна его некорректная работа в системе.
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>

  </div>
</div></form>
HTML;

}
// ********************************************************************************
// Проверка прав на запись
// ********************************************************************************
elseif($_REQUEST['action'] == "chmod_check") {

if ( !$_SESSION['dle_install'] ) msgbox( "", "Ошибка", "Установка скрипта была начата не с начала. Вернитесь на главную страницу начала установки скрипта: <br /><br /><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a>" );

  echo $skin_header;

echo <<<HTML
<form method="get" action="">
<input type=hidden name="action" value="doconfig">
<div class="panel panel-default">
  <div class="panel-heading">
    Проверка на запись у важных файлов системы
  </div>
  <div class="table-responsive">
<table class="table table-striped table-xs">
HTML;

echo"<thead><tr>
<th>Папка/Файл</th>
<th width=\"100\">CHMOD</th>
<th width=\"100\">Статус</th></tr></thead><tbody>";

$important_files = array(
'./backup/',
'./engine/data/',
'./engine/cache/',
'./engine/cache/system/',
'./engine/mods/miniposter/config.php',
'./uploads/',
'./uploads/files/',
'./uploads/fotos/',
'./uploads/posts/',
'./uploads/posts/thumbs/',
'./uploads/posts/medium/',
'./uploads/thumbs/',
'./templates/',
'./templates/Default/',
);


$chmod_errors = 0;
$not_found_errors = 0;
    foreach($important_files as $file){

        if(!file_exists($file)){
            $file_status = "<span class=\"text-danger\">не найден!</span>";
            $not_found_errors ++;
        }
        elseif(is_writable($file)){
            $file_status = "<span class=\"text-success\">разрешено</span>";
        }
        else{
            @chmod($file, 0777);
            if(is_writable($file)){
                $file_status = "<span class=\"text-success\">разрешено</span>";
            }else{
                @chmod("$file", 0755);
                if(is_writable($file)){
                    $file_status = "<span class=\"text-success\">разрешено</span>";
                }else{
                    $file_status = "<span class=\"text-danger\">запрещено</span>";
                    $chmod_errors ++;
                }
            }
        }
        $chmod_value = @decoct(@fileperms($file)) % 1000;

    echo"<tr>
         <td>$file</td>
         <td>$chmod_value</td>
         <td>$file_status</td>
         </tr>";
    }
    
if($chmod_errors == 0 and $not_found_errors == 0){

    $status_report = 'Проверка успешно завершена! Можете продолжить установку!';

} else {
    
    if($chmod_errors > 0){
        $status_report = "<span class=\"text-danger\">Внимание!!!</span><br /><br />Во время проверки обнаружены ошибки: <b>$chmod_errors</b>. Запрещена запись в файл.<br />Вы должны выставить для папок CHMOD 777, для файлов CHMOD 666, используя FTP клиент.<br /><br /><span class=\"text-danger\"><b>Настоятельно не рекомендуется</b></span> продолжать установку, пока не будут произведены изменения.<br />";
    }

    if($not_found_errors > 0){
        $status_report .= "<span class=\"text-danger\">Внимание!!!</span><br />Во время проверки обнаружены ошибки: <b>$not_found_errors</b>. Файлы не найдены!<br /><br /><span class=\"text-danger\"><b>Не рекомендуется</b></span> продолжать установку, пока не будут произведены изменения.<br />";
    }
}

echo <<<HTML
</tbody></table>
  </div>
  <div class="panel-body">
	{$status_report}
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>
</div></form>
HTML;

} elseif($_REQUEST['action'] == "doconfig") {

    if ( !$_SESSION['dle_install'] ) msgbox( "", "Ошибка", "Установка скрипта была начата не с начала. Вернитесь на главную страницу начала установки скрипта: <br /><br /><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a>" );
	
	$url = explode( "install.php", strtolower ( $_SERVER['PHP_SELF'] ) );
	$url = reset($url);

	if( isSSL() ) $url  = "https://".$_SERVER['HTTP_HOST'].$url;
	else $url  = "http://".$_SERVER['HTTP_HOST'].$url;


  echo $skin_header;

  echo <<<HTML
<form method="post" action="">
<input type=hidden name="action" value="doinstall">
<div class="panel panel-default">
  <div class="panel-heading">
    Настройка конфигурации системы
  </div>
  <div class="panel-body">
<table width="100%">
HTML;

if ( $distr_charset == "utf-8" ) {
	
	$mb4 = '<tr><td valign="top" style="padding: 5px;">4 байта UTF-8<td style="padding: 5px;"><div class="checkbox"><label><input class="icheck" type="checkbox" id="allow_mb4" name="allow_mb4" value="1" checked></label></div><span class="text-size-small text-muted">В случае включения данной опции, для базы данных будет использоватся четыре байта для кодировки UTF-8, это позволяет хранить в базе данных смайлы Emoji или музыкальные символы. При этом увеличивается расход памяти в базе данных</span></tr>';

} else $mb4 = "";

echo '<tr>
<td width="175" style="padding: 5px;vertical-align: top;">URL сайта:
<td><input name=url value="'.$url.'" class="classic width-400" type="text"><br><span class="text-size-small text-muted">Укажите путь без имени файла, знак слеша <span class="text-danger">/</span> на конце обязателен</span></tr>
<tr><td colspan="3" height="40">&nbsp;<b>Данные для доступа к MySQL серверу</b><td></tr>
<tr><td style="padding: 5px;">Сервер MySQL:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="dbhost" value="localhost"></tr>
<tr><td style="padding: 5px;">Имя базы данных:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;"" name="dbname"></tr>
<tr><td style="padding: 5px;">Имя пользователя:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="dbuser"></tr>
<tr><td style="padding: 5px;">Пароль:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="dbpasswd"></tr>
<tr><td style="padding: 5px;">Префикс:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="dbprefix" value="dle"> <span class="text-size-small text-muted">Не изменяйте параметр, если не знаете для чего он предназначен</span></tr>
<tr><td style="padding: 5px;">Движок базы данных:<td style="padding: 5px;"><select name="storage_engine" class="uniform"><option value="1">InnoDB</option><option value="0">MyISAM</option></select></tr>
'.$mb4.'
<tr><td colspan="3"  height="40">&nbsp;<b>Данные для доступа с которыми вы будете входить в админпанель скрипта</b><td></tr>
<tr><td style="padding: 5px;">Имя администратора:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="reg_username" ></tr>
<tr><td style="padding: 5px;">Пароль:<td style="padding: 5px;"><input type="password" class="classic" style="width:220px;" name="reg_password1"></tr>
<tr><td style="padding: 5px;">Повторите пароль:<td style="padding: 5px;"><input type="password" class="classic" style="width:220px;" name="reg_password2"></tr>
<tr><td style="padding: 5px;">E-mail:<td style="padding: 5px;"><input type="text" class="classic" style="width:220px;" name="reg_email"></tr>
<tr><td colspan="3"  height="40">&nbsp;<b>Дополнительные настройки</b><td></tr>
<tr><td style="padding: 5px;">Включить поддержку ЧПУ:
<td style="padding: 5px;">
<select class="uniform" name="alt_url"><option value="1">Да</option><option value="0">Нет</option></select><br><span class="text-size-small text-muted">Eсли вы отключите поддержку ЧПУ, то не забудьте удалить файл .htaccess в корневой папке</span>
</tr>';

echo <<<HTML
</table>
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>
</div></form>
HTML;

}
// ********************************************************************************
// Do Install
// ********************************************************************************
elseif($_REQUEST['action'] == "doinstall")
{

	if ( !$_SESSION['dle_install'] ) msgbox( "", "Ошибка", "Установка скрипта была начата не с начала. Вернитесь на главную страницу начала установки скрипта: <br /><br /><a href=\"http://{$_SERVER['HTTP_HOST']}/install.php\">http://{$_SERVER['HTTP_HOST']}/install.php</a>" );
		
  if( !$_POST['reg_username'] OR !$_POST['reg_email'] OR !$_POST['reg_password1'] OR !$_POST['url'] OR $_POST['reg_password1'] != $_POST['reg_password2'] ){ msgbox("error", "Ошибка!!!" ,"Заполните необходимые поля!", "history.go(-1)"); }
	
	if (preg_match("/[\||\'|\<|\>|\[|\]|\"|\!|\?|\$|\@|\#|\/|\\\|\&\~\*\{\+]/", $_POST['reg_username']))
	{
		msgbox("error", "Ошибка!!!" ,"Введенное имя администратора недопустимо к регистрации!", "history.go(-1)");
	}
	
	$reg_password = password_hash($_POST['reg_password1'], PASSWORD_DEFAULT);
	
	if( !$reg_password ) {
		msgbox("error", "Ошибка", "PHP extension Crypt must be loaded for password_hash to function", "history.go(-1)");
	}

	$reg_username = $_POST['reg_username'];
	$alt_url = intval( $_POST['alt_url'] );
	
	$url = htmlspecialchars(strip_tags(stripslashes($_POST['url'])), ENT_QUOTES, $distr_charset );
	$url = str_replace( "$", "&#036;", $url );

	$not_allow_symbol = array ("\x22", "\x60", "\t", '\n', '\r', "\n", "\r", '\\', ",", "/", "¬", "#", ";", ":", "~", "[", "]", "{", "}", ")", "(", "*", "^", "%", "$", "<", ">", "?", "!", '"', "'", " ", "&" );
	$reg_email = trim( str_replace( $not_allow_symbol, '', strip_tags( stripslashes( $_POST['reg_email'] ) ) ) );

	$timezone = date_default_timezone_get();
	
	$timezones = array('Pacific/Midway','US/Samoa','US/Hawaii','US/Alaska','US/Pacific','America/Tijuana','US/Arizona','US/Mountain','America/Chihuahua','America/Mazatlan','America/Mexico_City','America/Monterrey','US/Central','US/Eastern','US/East-Indiana','America/Lima','America/Caracas','Canada/Atlantic','America/La_Paz','America/Santiago','Canada/Newfoundland','America/Buenos_Aires','Greenland','Atlantic/Stanley','Atlantic/Azores','Africa/Casablanca','Europe/Dublin','Europe/Lisbon','Europe/London','Europe/Amsterdam','Europe/Belgrade','Europe/Berlin','Europe/Bratislava','Europe/Brussels','Europe/Budapest','Europe/Copenhagen','Europe/Madrid','Europe/Paris','Europe/Prague','Europe/Rome','Europe/Sarajevo','Europe/Stockholm','Europe/Vienna','Europe/Warsaw','Europe/Zagreb','Europe/Athens','Europe/Bucharest','Europe/Helsinki','Europe/Istanbul','Asia/Jerusalem','Europe/Kiev','Europe/Minsk','Europe/Riga','Europe/Sofia','Europe/Tallinn','Europe/Vilnius','Asia/Baghdad','Asia/Kuwait','Africa/Nairobi','Asia/Tehran','Europe/Kaliningrad','Europe/Moscow','Europe/Volgograd','Europe/Samara','Asia/Baku','Asia/Muscat','Asia/Tbilisi','Asia/Yerevan','Asia/Kabul','Asia/Yekaterinburg','Asia/Tashkent','Asia/Kolkata','Asia/Kathmandu','Asia/Almaty','Asia/Novosibirsk','Asia/Jakarta','Asia/Krasnoyarsk','Asia/Hong_Kong','Asia/Kuala_Lumpur','Asia/Singapore','Asia/Taipei','Asia/Ulaanbaatar','Asia/Urumqi','Asia/Irkutsk','Asia/Seoul','Asia/Tokyo','Australia/Adelaide','Australia/Darwin','Asia/Yakutsk','Australia/Brisbane','Pacific/Port_Moresby','Australia/Sydney','Asia/Vladivostok','Asia/Sakhalin','Asia/Magadan','Pacific/Auckland','Pacific/Fiji');

	if ( !in_array($timezone, $timezones) ) {
		$timezone = "Europe/Moscow";
		date_default_timezone_set ( $timezone );
	}

	if ( $distr_charset == "utf-8" AND $_POST['allow_mb4']) {
		$db_charset = "utf8mb4";
	}
	
	$dbhost = str_replace ('"', '\"', str_replace ("$", "\\$", $_POST['dbhost']) );
	$dbname = str_replace ('"', '\"', str_replace ("$", "\\$", $_POST['dbname']) );
	$dbuser = str_replace ('"', '\"', str_replace ("$", "\\$", $_POST['dbuser']) );
	$dbpasswd = str_replace ('"', '\"', str_replace ("$", "\\$", $_POST['dbpasswd']) );
	$dbprefix = str_replace ('"', '\"', str_replace ("$", "\\$", $_POST['dbprefix']) );
	$auth_key = generate_auth_key();
	
	define ("PREFIX", $dbprefix);
	define ("COLLATE", $db_charset);

	include ENGINE_DIR.'/classes/mysql.php';
	
	$check_db = new db;
	
	if ( !$check_db->connect($dbuser, $dbpasswd, $dbname, $dbhost, false) ) {
		msgbox("error", "Ошибка!!!" ,"Невозможно соединиться с MySQL сервером по указанным доступам. Введите корректные данные доступа для соединения с БД MySQL", "history.go(-1)");
	}

	if ( $_POST['storage_engine']) {
		if( version_compare($check_db->mysql_version, '5.6.4', '<') ) {
			$storage_engine = "MyISAM";
		} else $storage_engine = "InnoDB";
		
	} else $storage_engine = "MyISAM";

	unset($check_db);
	
$config = <<<HTML
<?PHP

//System Configurations

\$config = array (

'version_id' => "12.0",

'home_title' => "Киного смотреть фильмы и сериалы онлайн",

'http_home_url' => "{$url}",

'charset' => "{$distr_charset}",

'admin_mail' => "{$reg_email}",

'description' => "",

'keywords' => "фильмы бесплатно, кино смотреть онлайн",

'short_title' => 'Киного',

'start_site' => '1',

'date_adjust' => "{$timezone}",

'site_offline' => "0",

'allow_alt_url' => '1',

'seo_type' => '2',

'seo_control' => '1',

'langs' => 'Russian',

'skin' => 'kinogo_adptv',

'allow_admin_wysiwyg' => '0',

'allow_static_wysiwyg' => '0',

'allow_complaint_mail' => '1',

'offline_reason' => 'Сайт находится на текущей реконструкции, после завершения всех работ сайт будет открыт.<br><br>Приносим вам свои извинения за доставленные неудобства.',

'admin_path' => 'admin.php',

'extra_login' => '0',

'admin_allowed_ip' => '',

'login_log' => '5',

'login_ban_timeout' => '20',

'ip_control' => '1',

'allow_recaptcha' => '0',

'recaptcha_public_key' => '',

'recaptcha_private_key' => '',

'recaptcha_theme' => 'light',

'adminlog_maxdays' => '30',

'news_number' => '10',

'search_number' => '10',

'search_pages' => '5',

'related_number' => '5',

'top_number' => '10',

'tags_number' => '40',

'max_moderation' => '0',

'news_restricted' => '0',

'category_separator' => '/',

'speedbar_separator' => '&raquo;',

'smilies' => 'bowtie,smile,laughing,blush,smiley,relaxed,smirk,heart_eyes,kissing_heart,kissing_closed_eyes,flushed,relieved,satisfied,grin,wink,stuck_out_tongue_winking_eye,stuck_out_tongue_closed_eyes,grinning,kissing,stuck_out_tongue,sleeping,worried,frowning,anguished,open_mouth,grimacing,confused,hushed,expressionless,unamused,sweat_smile,sweat,disappointed_relieved,weary,pensive,disappointed,confounded,fearful,cold_sweat,persevere,cry,sob,joy,astonished,scream,tired_face,angry,rage,triumph,sleepy,yum,mask,sunglasses,dizzy_face,imp,smiling_imp,neutral_face,no_mouth,innocent',

'timestamp_active' => 'j-m-Y, H:i',

'news_navigation' => '1',

'news_sort' => 'date',

'news_msort' => 'DESC',

'catalog_sort' => 'date',

'catalog_msort' => 'DESC',

'create_metatags' => '1',

'mail_news' => '1',

'show_sub_cats' => '1',

'allow_search_print' => '1',

'allow_add_tags' => '1',

'allow_share' => '1',

'short_rating' => '1',

'rating_type' => '0',

'allow_site_wysiwyg' => '1',

'allow_quick_wysiwyg' => '1',

'allow_comments' => '1',

'tree_comments_level' => '5',

'comments_restricted' => '0',

'allow_subscribe' => '1',

'allow_combine' => '1',

'max_comments_days' => '0',

'comments_minlen' => '10',

'comments_maxlen' => '3000',

'comm_nummers' => '30',

'comm_msort' => 'ASC',

'flood_time' => '30',

'auto_wrap' => '80',

'timestamp_comment' => 'j F Y H:i',

'allow_search_link' => '1',

'mail_comments' => '1',

'allow_comments_rating' => '1',

'comments_rating_type' => '1',

'allow_comments_wysiwyg' => '1',

'allow_cache' => '1',

'clear_cache' => '30',

'max_cache_pages' => '10',

'fullcache_days' => '30',

'cache_type' => '0',

'memcache_server' => 'localhost:11211',

'allow_comments_cache' => '1',

'allow_gzip' => '1',

'js_min' => '1',

'full_search' => '0',

'fast_search' => '1',

'allow_registration' => '1',

'allow_multi_category' => '1',

'related_news' => '1',

'no_date' => '1',

'allow_fixed' => '1',

'speedbar' => '1',

'allow_banner' => '1',

'allow_votes' => '1',

'allow_topnews' => '1',

'allow_read_count' => '1',

'category_newscount' => '1',

'allow_calendar' => '1',

'allow_archives' => '1',

'rss_informer' => '1',

'allow_tags' => '1',

'allow_change_sort' => '1',

'online_status' => '1',

'allow_links' => '1',

'max_file_count' => '0',

'admin_mail' => '123',

'mail_title' => 'Тестовый сайт о кино',

'mail_metod' => 'php',

'smtp_host' => 'localhost',

'smtp_port' => '25',

'smtp_user' => '',

'smtp_pass' => '',

'smtp_secure' => '',

'smtp_mail' => '',

'auth_metod' => '0',

'twofactor_auth' => '1',

'reg_group' => '4',

'registration_type' => '0',

'sec_addnews' => '2',

'spam_api_key' => '',

'profile_news' => '1',

'reg_multi_ip' => '1',

'auth_domain' => '0',

'registration_rules' => '1',

'allow_sec_code' => '1',

'allow_skin_change' => '1',

'mail_pm' => '1',

'max_users' => '0',

'max_users_day' => '0',

'max_up_side' => '0',

'o_seite' => '0',

'max_up_size' => '200',

'max_image_days' => '2',

'allow_watermark' => '1',

'max_watermark' => '150',

'watermark_seite' => '4',

'max_image' => '200',

'medium_image' => '450',

't_seite' => '0',

'jpeg_quality' => '85',

'avatar_size' => '100',

'tag_img_width' => '0',

'image_align' => 'center',

'thumb_gallery' => '1',

'outlinetype' => '0',

'mobile_news' => '10',

'rss_mtype' => '0',

'rss_number' => '10',

'rss_format' => '1',

'site_offline' => '0',

'log_hash' => '0',

'news_future' => '0',

'create_catalog' => '0',

'parse_links' => '0',

'related_only_cats' => '0',

'hide_full_link' => '0',

'allow_cmod' => '0',

'cache_count' => '0',

'comments_ajax' => '0',

'files_allow' => '0',

'files_count' => '0',

'files_force' => '0',

'files_antileech' => '0',

'use_admin_mail' => '0',

'mail_bcc' => '0',

'reg_question' => '0',

'thumb_dimming' => '0',

'allow_smartphone' => '0',

'allow_smart_images' => '0',

'allow_smart_video' => '0',

'allow_smart_format' => '0',

'allow_rss' => '0',

'comments_lazyload' => '0',

'allow_social' => '0',

'auth_only_social' => '0',

'tree_comments' => '0',

'simple_reply' => '0',

'only_ssl' => '0',

'allow_redirects' => '0',

'allow_own_meta' => '0',

'bbimages_in_wysiwyg' => '0',

'version_id' => '12.0',

'key' => '8029c2808658bfe155299bc5dfe7ec25',

);

?>
HTML;


$dbconfig = <<<HTML
<?PHP

define ("DBHOST", "{$dbhost}");

define ("DBNAME", "{$dbname}");

define ("DBUSER", "{$dbuser}");

define ("DBPASS", "{$dbpasswd}");

define ("PREFIX", "{$dbprefix}");

define ("USERPREFIX", "{$dbprefix}");

define ("COLLATE", "{$db_charset}");

define('SECURE_AUTH_KEY', '{$auth_key}');

\$db = new db;

?>
HTML;


$video_config = <<<HTML
<?PHP

//Videoplayers Configurations

\$video_config = array (

'width' => "560",

'audio_width' => "560",

'preload' => '1',

'theme' => 'default',

);

?>
HTML;


$social_config = <<<HTML
<?PHP

//Social Configurations

\$social_config = array (

'vk' => '0',

'vkid' => '',

'vksecret' => '',

'od' => '0',

'odid' => '',

'odpublic' => '',

'odsecret' => '',

'fc' => '0',

'fcid' => '',

'fcsecret' => '',

'google' => '0',

'googleid' => '',

'googlesecret' => '',

'mailru' => '0',

'mailruid' => '',

'mailrusecret' => '',

'yandex' => '0',

'yandexid' => '',

'yandexsecret' => '',

);

?>
HTML;

$wordfilter_config = <<<HTML
1491585688|http||0|0|2|1||
1491585716|www||0|0|2|1||
1491585790|&#||0|0|2|1||
HTML;

$xfields_config = <<<HTML
video|Плеер||text||1|0|0|0
trailer|Трейлер фильма||text||1|0|0|0
kp_id|id на кинопоиск||text||1|0|0|0
year|Год фильма||text||1|0|0|0
origin|Оригинальное название фильма||text||1|0|0|0
genre|Жанр||text||1|0|0|0
country|Страна фильма||text||1|0|0|0
time|Продолжительность фильма||text||1|0|0|0
director|Режисер фильма||text||1|0|0|0
poster|Постер||text||1|0|0|0
premier|Премьера||text||1|0|0|0
sound|Перевод фильма||text||1|0|0|0
quality|Качество фильма|1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,28|select|Трейлер__NEWL__HDRip__NEWL__CAMRip__NEWL__TS__NEWL__DVDRip__NEWL__удалено|0|0|0|0|||0|0||||||||
actors|Актеры фильма||text||1|0|0|0
skoro|Скоро на сайте Новинки||text||1|0|0|0
popf|Слайдер||text||1|0|0|0|||0|0||||||||
serials-status|Статус сериала|25,26,27|select|Снимается__NEWL__Закончен|0|0|0|0
serials-studios|Озвучка ||text||1|0|0|0
serials-season|Сезон сериала||text||1|0|0|0|||0|0||||||||
serii|Серия||text||1|0|0|0
dopserial|хвост к сериалам||text||1|0|0|0|||0|0||||||||
hdgo|Плеер HDGO||text||1|0|0|0|||0|0||||||||
vk|Плеер Вконтакте||text||1|0|0|0|||0|0||||||||
vkvideo|Вквидео||text||1|0|0|0|||0|0||||||||
HTML;

# Miniposter lickey generator [SeoPirat]
$shost = str_replace( 'www.', '', strtolower( getenv( 'HTTP_HOST' ) ) );
$shost = md5( 'mp' . md5( $shost ) . 'poster' );
$poster_key = strtoupper( substr( $shost, 0, 5 ) . '-' . substr( $shost, 6, 5 ) . '-' . substr( $shost, 12, 5 ) . '-' . substr( $shost, 18, 5 ) . '-' . substr( $shost, 24, 5 ) );

$miniposter_config = <<<HTML
<?PHP
return array(
  'activate' => '{$poster_key}',  //ключ активации
  'max_width' => 800,   //максимальная ширина минипостера
  'max_height' => 800,  //максимальная высота минипостера
  'quality' => 75,    //качество по умолчанию
  'default' => '/uploads/mini/noimage.jpg', //картинка по умолчанию
  'allow_remote' => 1,  //разрешить обработку изображений со сторонних серверов
  'zoom' => 0,  //1 - увеличивать маленькие изображения до заданных размеров. 0 - просто обрезать большую сторону при необходимости
  'force_jpg' => 1, //1 - по умолчанию сохранять только в jpg. 0 - сохранять в исходном типе
  'save_path' => "/uploads/mini/",  //путь сохранения картинок
  'timeout' => 2,   //время ожидания (сек) ответа при обработке изображений со сторонних сайтов.
);
?>
HTML;

$con_file = fopen("engine/mods/miniposter/config.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/mods/miniposter/config.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $miniposter_config);
fclose($con_file);
@chmod("engine/mods/miniposter/config.php", 0666);

# Original
$con_file = fopen("engine/data/config.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/config.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $config);
fclose($con_file);
@chmod("engine/data/config.php", 0666);

$con_file = fopen("engine/data/dbconfig.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/dbconfig.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $dbconfig);
fclose($con_file);
@chmod("engine/data/dbconfig.php", 0666);

$con_file = fopen("engine/data/videoconfig.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/videoconfig.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $video_config);
fclose($con_file);
@chmod("engine/data/videoconfig.php", 0666);

$con_file = fopen("engine/data/socialconfig.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/socialconfig.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $social_config);
fclose($con_file);
@chmod("engine/data/socialconfig.php", 0666);

$con_file = fopen("engine/data/wordfilter.db.php", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/wordfilter.db.php</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $wordfilter_config);
fclose($con_file);
@chmod("engine/data/wordfilter.db.php", 0666);

$con_file = fopen("engine/data/xfields.txt", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/xfields.txt</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, $xfields_config);
fclose($con_file);
@chmod("engine/data/xfields.txt", 0666);

$con_file = fopen("engine/data/xprofile.txt", "w+") or die("Извините, но невозможно создать файл <b>.engine/data/xprofile.txt</b>.<br />Проверьте правильность проставленного CHMOD!");
fwrite($con_file, '');
fclose($con_file);
@chmod("engine/data/xprofile.txt", 0666);

@unlink(ENGINE_DIR.'/cache/system/usergroup.php');
@unlink(ENGINE_DIR.'/cache/system/vote.php');
@unlink(ENGINE_DIR.'/cache/system/banners.php');
@unlink(ENGINE_DIR.'/cache/system/category.php');
@unlink(ENGINE_DIR.'/cache/system/banned.php');
@unlink(ENGINE_DIR.'/cache/system/cron.php');
@unlink(ENGINE_DIR.'/cache/system/informers.php');
@unlink(ENGINE_DIR.'/data/snap.db');

listdir( ENGINE_DIR . '/cache/system/CSS' );
listdir( ENGINE_DIR . '/cache/system/HTML' );
listdir( ENGINE_DIR . '/cache/system/URI' );
clear_cache();

include ENGINE_DIR.'/data/dbconfig.php';

$reg_username = $db->safesql( $reg_username );
$reg_password = $db->safesql( $reg_password );

$tableSchema = array();

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_category";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_category (
  `id` mediumint(8) NOT NULL auto_increment,
  `parentid` mediumint(8) NOT NULL default '0',
  `posi` mediumint(8) NOT NULL default '1',
  `name` varchar(50) NOT NULL default '',
  `alt_name` varchar(50) NOT NULL default '',
  `icon` varchar(200) NOT NULL default '',
  `skin` varchar(50) NOT NULL default '',
  `descr` varchar(200) NOT NULL default '',
  `keywords` text NOT NULL,
  `news_sort` varchar(10) NOT NULL default '',
  `news_msort` varchar(4) NOT NULL default '',
  `news_number` smallint(5) NOT NULL default '0',
  `short_tpl` varchar(40) NOT NULL default '',
  `full_tpl` varchar(40) NOT NULL default '',
  `metatitle` varchar(255) NOT NULL default '',
  `show_sub` tinyint(1) NOT NULL default '0',
  `allow_rss` tinyint(1) NOT NULL default '1',
  `fulldescr` text NOT NULL,
  `disable_search` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

#CategoryFace [SeoPirat]
$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_category_face";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_category_face (
  `category_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `name_pages` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `description_pages` text NOT NULL,
  `module_placement` enum('nowhere','first_page','all_pages') NOT NULL,
  `show_name` enum('show','default','hide') NOT NULL,
  `show_description` enum('show','default','hide') NOT NULL,
  `name_placement` enum('first_page','all_pages') NOT NULL,
  `description_placement` enum('first_page','all_pages') NOT NULL,
  PRIMARY KEY (`category_id`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

#HDLight_Voice [SeoPirat]
$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_hdlight_voice";
$tableSchema[] = "CREATE TABLE IF NOT EXISTS " . PREFIX . "_hdlight_voice (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `voice_id` int(11) NOT NULL,
  `voice_name` varchar(128) NOT NULL,
  `film_priority` int(11) NOT NULL DEFAULT '0',
  `serial_priority` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";


$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_comments";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_comments (
  `id` int(10) unsigned NOT NULL auto_increment,
  `post_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '2000-01-01 00:00:00',
  `autor` varchar(40) NOT NULL default '',
  `email` varchar(40) NOT NULL default '',
  `text` text NOT NULL,
  `ip` varchar(40) NOT NULL default '',
  `is_register` tinyint(1) NOT NULL default '0',
  `approve` tinyint(1) NOT NULL default '1',
  `rating` int(11) NOT NULL default '0',
  `vote_num` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`),
  KEY `post_id` (`post_id`),
  KEY `approve` (`approve`),
  KEY `parent` (`parent`),
  KEY `rating` (`rating`),
  FULLTEXT KEY `text` (`text`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_email";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_email (
  `id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(10) NOT NULL default '',
  `template` text NOT NULL,
  `use_html` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";


$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_flood";

$tableSchema[] = "CREATE TABLE  " . PREFIX . "_flood (
  `f_id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(40) NOT NULL default '',
  `id` varchar(20) NOT NULL default '',
  `flag` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`f_id`),
  KEY `ip` (`ip`),
  KEY `id` (`id`),
  KEY `flag` (`flag`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_images";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_images (
  `id` int(10) unsigned NOT NULL auto_increment,
  `images` text NOT NULL,
  `news_id` int(10) NOT NULL default '0',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `author` (`author`),
  KEY `news_id` (`news_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_logs";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_logs (
  `id` int(10) unsigned NOT NULL auto_increment,
  `news_id` int(10) NOT NULL default '0',
  `member` varchar(40) NOT NULL default '',
  `ip` varchar(40) NOT NULL default '',
  `rating` TINYINT(4) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `member` (`member`),
  KEY `ip` (`ip`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_vote";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_vote (
  `id` mediumint(8) NOT NULL auto_increment,
  `category` text NOT NULL,
  `vote_num` mediumint(8) NOT NULL default '0',
  `date` varchar(25) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `body` text NOT NULL,
  `approve` tinyint(1) NOT NULL default '1',
  `start` varchar(15) NOT NULL default '',
  `end` varchar(15) NOT NULL default '',
  `grouplevel` varchar(250) NOT NULL default 'all',
  PRIMARY KEY  (`id`),
  KEY `approve` (`approve`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_vote_result";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_vote_result (
  `id` int(10) NOT NULL auto_increment,
  `ip` varchar(40) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  `vote_id` mediumint(8) NOT NULL default '0',
  `answer` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `answer` (`answer`),
  KEY `vote_id` (`vote_id`),
  KEY `ip` (`ip`),
  KEY `name` (`name`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_lostdb";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_lostdb (
  `id` mediumint(8) NOT NULL auto_increment,
  `lostname` mediumint(8) NOT NULL default '0',
  `lostid` varchar( 40 ) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `lostid` (`lostid`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_pm";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_pm (
  `id` int(11) unsigned NOT NULL auto_increment,
  `subj` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `user` MEDIUMINT(8) NOT NULL default '0',
  `user_from` varchar(40) NOT NULL default '',
  `date` int(11) unsigned NOT NULL default '0',
  `pm_read` TINYINT(1) NOT NULL default '0',
  `folder` varchar(10) NOT NULL default '',
  `reply` tinyint(1) NOT NULL default '0',
  `sendid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `folder` (`folder`),
  KEY `user` (`user`),
  KEY `user_from` (`user_from`),
  KEY `pm_read` (`pm_read`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_post";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_post (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `autor` varchar(40) NOT NULL DEFAULT '',
  `date` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `short_story` mediumtext NOT NULL,
  `full_story` mediumtext NOT NULL,
  `xfields` mediumtext NOT NULL,
  `title` varchar(255) NOT NULL DEFAULT '',
  `descr` varchar(200) NOT NULL DEFAULT '',
  `keywords` text NOT NULL,
  `category` varchar(190) NOT NULL DEFAULT '0',
  `alt_name` varchar(190) NOT NULL DEFAULT '',
  `comm_num` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `allow_comm` tinyint(1) NOT NULL DEFAULT '1',
  `allow_main` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `approve` tinyint(1) NOT NULL DEFAULT '0',
  `fixed` tinyint(1) NOT NULL DEFAULT '0',
  `allow_br` tinyint(1) NOT NULL DEFAULT '1',
  `symbol` varchar(3) NOT NULL DEFAULT '',
  `tags` varchar(250) NOT NULL DEFAULT '',
  `metatitle` varchar(255) NOT NULL DEFAULT '',
  `kp_id_movie` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `autor` (`autor`),
  KEY `alt_name` (`alt_name`),
  KEY `category` (`category`),
  KEY `approve` (`approve`),
  KEY `allow_main` (`allow_main`),
  KEY `date` (`date`),
  KEY `symbol` (`symbol`),
  KEY `comm_num` (`comm_num`),
  KEY `fixed` (`fixed`),
  FULLTEXT KEY `short_story` (`short_story`,`full_story`,`xfields`,`title`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_post_extras";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_post_extras (
  `eid` int(11) NOT NULL AUTO_INCREMENT,
  `news_id` int(11) NOT NULL DEFAULT '0',
  `news_read` int(11) NOT NULL DEFAULT '0',
  `allow_rate` tinyint(1) NOT NULL DEFAULT '1',
  `rating` int(11) NOT NULL DEFAULT '0',
  `vote_num` int(11) NOT NULL DEFAULT '0',
  `votes` tinyint(1) NOT NULL DEFAULT '0',
  `view_edit` tinyint(1) NOT NULL DEFAULT '0',
  `disable_index` tinyint(1) NOT NULL DEFAULT '0',
  `related_ids` varchar(255) NOT NULL DEFAULT '',
  `access` varchar(150) NOT NULL DEFAULT '',
  `editdate` int(11) unsigned NOT NULL DEFAULT '0',
  `editor` varchar(40) NOT NULL DEFAULT '',
  `reason` varchar(255) NOT NULL DEFAULT '',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `disable_search` tinyint(1) NOT NULL DEFAULT '0',
  `need_pass` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`eid`),
  KEY `news_id` (`news_id`),
  KEY `user_id` (`user_id`),
  KEY `rating` (`rating`),
  KEY `disable_search` (`disable_search`),
  KEY `news_read` (`news_read`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_static";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_static (
  `id` MEDIUMINT(8) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `descr` varchar(255) NOT NULL default '',
  `template` MEDIUMTEXT NOT NULL,
  `allow_br` tinyint(1) NOT NULL default '0',
  `allow_template` tinyint(1) NOT NULL default '0',
  `grouplevel` varchar(100) NOT NULL default 'all',
  `tpl` varchar(40) NOT NULL default '',
  `metadescr` varchar(200) NOT NULL default '',
  `metakeys` text NOT NULL,
  `views` mediumint(8) NOT NULL default '0',
  `template_folder` varchar(50) NOT NULL default '',
  `date` int(11) unsigned NOT NULL default '0',
  `metatitle` varchar(255) NOT NULL default '',
  `allow_count` tinyint(1) NOT NULL default '1',
  `sitemap` tinyint(1) NOT NULL default '1',
  `disable_index` tinyint(1) NOT NULL default '0',
  `disable_search` tinyint(1) NOT NULL default '0',
  `password` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `disable_search` (`disable_search`),
  FULLTEXT KEY `template` (`template`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_users";

$tableSchema[] = "CREATE TABLE " . PREFIX . "_users (
  `email` varchar(50) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  `user_id` int(11) NOT NULL auto_increment,
  `news_num` mediumint(8) NOT NULL default '0',
  `comm_num` mediumint(8) NOT NULL default '0',
  `user_group` smallint(5) NOT NULL default '4',
  `lastdate` varchar(20) NOT NULL default '',
  `reg_date` varchar(20) NOT NULL default '',
  `banned` varchar(5) NOT NULL default '',
  `allow_mail` tinyint(1) NOT NULL default '1',
  `info` text NOT NULL,
  `signature` text NOT NULL,
  `foto` varchar(255) NOT NULL default '',
  `fullname` varchar(100) NOT NULL default '',
  `land` varchar(100) NOT NULL default '',
  `favorites` text NOT NULL,
  `pm_all` smallint(5) NOT NULL default '0',
  `pm_unread` smallint(5) NOT NULL default '0',
  `time_limit` varchar(20) NOT NULL default '',
  `xfields` text NOT NULL,
  `allowed_ip` varchar(255) NOT NULL default '',
  `hash` varchar(32) NOT NULL default '',
  `logged_ip` varchar(40) NOT NULL default '',
  `restricted` TINYINT(1) NOT NULL default '0',
  `restricted_days` SMALLINT(4) NOT NULL default '0',
  `restricted_date` VARCHAR(15) NOT NULL default '',
  `timezone` VARCHAR(100) NOT NULL default '',
  `news_subscribe` tinyint(1) NOT NULL default '0',
  `comments_reply_subscribe` tinyint(1) NOT NULL default '0',
  `twofactor_auth` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `email` (`email`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_banned";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_banned (
  `id` smallint(5) NOT NULL auto_increment,
  `users_id` int(11) NOT NULL default '0',
  `descr` text NOT NULL,
  `date` varchar(15) NOT NULL default '',
  `days` smallint(4) NOT NULL default '0',
  `ip` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `user_id` (`users_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_files";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_files (
  `id` int(11) NOT NULL auto_increment,
  `news_id` int(11) NOT NULL default '0',
  `name` varchar(250) NOT NULL default '',
  `onserver` varchar(250) NOT NULL default '',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  `dcount` int(11) NOT NULL default '0',
  `size` bigint(20) NOT NULL default '0',
  `checksum` char(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_usergroups";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_usergroups (
  `id` smallint(5) NOT NULL auto_increment,
  `group_name` varchar(50) NOT NULL default '',
  `allow_cats` text NOT NULL,
  `allow_adds` tinyint(1) NOT NULL default '1',
  `cat_add` text NOT NULL,
  `allow_admin` tinyint(1) NOT NULL default '0',
  `allow_addc` tinyint(1) NOT NULL default '0',
  `allow_editc` tinyint(1) NOT NULL default '0',
  `allow_delc` tinyint(1) NOT NULL default '0',
  `edit_allc` tinyint(1) NOT NULL default '0',
  `del_allc` tinyint(1) NOT NULL default '0',
  `moderation` tinyint(1) NOT NULL default '0',
  `allow_all_edit` tinyint(1) NOT NULL default '0',
  `allow_edit` tinyint(1) NOT NULL default '0',
  `allow_pm` tinyint(1) NOT NULL default '0',
  `max_pm` smallint(5) NOT NULL default '0',
  `max_foto` VARCHAR(10) NOT NULL default '',
  `allow_files` tinyint(1) NOT NULL default '0',
  `allow_hide` tinyint(1) NOT NULL default '1',
  `allow_short` tinyint(1) NOT NULL default '0',
  `time_limit` tinyint(1) NOT NULL default '0',
  `rid` smallint(5) NOT NULL default '0',
  `allow_fixed` tinyint(1) NOT NULL default '0',
  `allow_feed`  tinyint(1) NOT NULL default '1',
  `allow_search`  tinyint(1) NOT NULL default '1',
  `allow_poll`  tinyint(1) NOT NULL default '1',
  `allow_main`  tinyint(1) NOT NULL default '1',
  `captcha`  tinyint(1) NOT NULL default '0',
  `icon` varchar(200) NOT NULL default '',
  `allow_modc`  tinyint(1) NOT NULL default '0',
  `allow_rating` tinyint(1) NOT NULL default '1',
  `allow_offline` tinyint(1) NOT NULL default '0',
  `allow_image_upload` tinyint(1) NOT NULL default '0',
  `allow_file_upload` tinyint(1) NOT NULL default '0',
  `allow_signature` tinyint(1) NOT NULL default '0',
  `allow_url` tinyint(1) NOT NULL default '1',
  `news_sec_code` tinyint(1) NOT NULL default '1',
  `allow_image` tinyint(1) NOT NULL default '0',
  `max_signature` SMALLINT(6) NOT NULL default '0',
  `max_info` SMALLINT(6) NOT NULL default '0',
  `admin_addnews` tinyint(1) NOT NULL default '0',
  `admin_editnews` tinyint(1) NOT NULL default '0',
  `admin_comments` tinyint(1) NOT NULL default '0',
  `admin_categories` tinyint(1) NOT NULL default '0',
  `admin_editusers` tinyint(1) NOT NULL default '0',
  `admin_wordfilter` tinyint(1) NOT NULL default '0',
  `admin_xfields` tinyint(1) NOT NULL default '0',
  `admin_userfields` tinyint(1) NOT NULL default '0',
  `admin_static` tinyint(1) NOT NULL default '0',
  `admin_editvote` tinyint(1) NOT NULL default '0',
  `admin_newsletter` tinyint(1) NOT NULL default '0',
  `admin_blockip` tinyint(1) NOT NULL default '0',
  `admin_banners` tinyint(1) NOT NULL default '0',
  `admin_rss` tinyint(1) NOT NULL default '0',
  `admin_iptools` tinyint(1) NOT NULL default '0',
  `admin_rssinform` tinyint(1) NOT NULL default '0',
  `admin_googlemap` tinyint(1) NOT NULL default '0',
  `allow_html` tinyint(1) NOT NULL default '1',
  `group_prefix` text NOT NULL,
  `group_suffix` text NOT NULL,
  `allow_subscribe` tinyint(1) NOT NULL default '0',
  `allow_image_size` tinyint(1) NOT NULL default '0',
  `cat_allow_addnews` text NOT NULL,
  `flood_news` smallint(6) NOT NULL default '0',
  `max_day_news` smallint(6) NOT NULL default '0',
  `force_leech` tinyint(1) NOT NULL default '0',
  `edit_limit` smallint(6) NOT NULL default '0',
  `captcha_pm` tinyint(1) NOT NULL default '0',
  `max_pm_day` smallint(6) NOT NULL default '0',
  `max_mail_day` smallint(6) NOT NULL default '0',
  `admin_tagscloud` tinyint(1) NOT NULL default '0',
  `allow_vote` tinyint(1) NOT NULL default '0',
  `admin_complaint` tinyint(1) NOT NULL default '0',
  `news_question` tinyint(1) NOT NULL default '0',
  `comments_question` tinyint(1) NOT NULL default '0',
  `max_comment_day` smallint(6) NOT NULL default '0',
  `max_images` smallint(6) NOT NULL default '0',
  `max_files` smallint(6) NOT NULL default '0',
  `disable_news_captcha` smallint(6) NOT NULL default '0',
  `disable_comments_captcha` smallint(6) NOT NULL default '0',
  `pm_question` tinyint(1) NOT NULL default '0',
  `captcha_feedback` tinyint(1) NOT NULL default '1',
  `feedback_question` tinyint(1) NOT NULL default '0',
  `files_type` varchar(255) NOT NULL default '',
  `max_file_size` mediumint(9) NOT NULL default '0',
  `files_max_speed` smallint(6) NOT NULL default '0',
  `spamfilter` tinyint(1) NOT NULL default '2',
  `allow_comments_rating` tinyint(1) NOT NULL default '1',
  `max_edit_days` tinyint(1) NOT NULL default '0',
  `spampmfilter` tinyint(1) NOT NULL default '0',
  `force_reg` TINYINT(1) NOT NULL default '0',
  `force_reg_days` MEDIUMINT(9) NOT NULL default '0',
  `force_reg_group` SMALLINT(6) NOT NULL default '4',
  `force_news` TINYINT(1) NOT NULL default '0',
  `force_news_count` MEDIUMINT(9) NOT NULL default '0',
  `force_news_group` SMALLINT(6) NOT NULL default '4',
  `force_comments` TINYINT(1) NOT NULL default '0',
  `force_comments_count` MEDIUMINT(9) NOT NULL default '0',
  `force_comments_group` SMALLINT(6) NOT NULL default '4',
  `force_rating` TINYINT(1) NOT NULL default '0',
  `force_rating_count` MEDIUMINT(9) NOT NULL default '0',
  `force_rating_group` SMALLINT(6) NOT NULL default '4',
  `not_allow_cats` text NOT NULL,
  `allow_up_image` TINYINT(1) NOT NULL default '0',
  `allow_up_watermark` TINYINT(1) NOT NULL default '0',
  `allow_up_thumb` TINYINT(1) NOT NULL default '0',
  `up_count_image` SMALLINT(6) NOT NULL default '0',
  `up_image_side` varchar(20) NOT NULL default '',
  `up_image_size` MEDIUMINT(9) NOT NULL default '0',
  `up_thumb_size` varchar(20) NOT NULL default '',
  `allow_mail_files` TINYINT(1) NOT NULL DEFAULT '0',
  `max_mail_files` SMALLINT(6) NOT NULL DEFAULT '0',
  `max_mail_allfiles` MEDIUMINT(9) NOT NULL DEFAULT '0',
  `mail_files_type` VARCHAR(100) NOT NULL DEFAULT '',
  `video_comments` TINYINT(1) NOT NULL DEFAULT '0',
  `media_comments` TINYINT(1) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";


$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_poll";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_poll (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `news_id` int(10) unsigned NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `frage` varchar(200) NOT NULL default '',
  `body` text NOT NULL,
  `votes` mediumint(8) NOT NULL default '0',
  `multiple` tinyint(1) NOT NULL default '0',
  `answer` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_poll_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_poll_log (
  `id` int(10) unsigned NOT NULL auto_increment,
  `news_id` int(10) unsigned NOT NULL default '0',
  `member` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `member` (`member`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_banners";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_banners (
  `id` smallint(5) NOT NULL auto_increment,
  `banner_tag` varchar(40) NOT NULL default '',
  `descr` varchar(200) NOT NULL default '',
  `code` text NOT NULL,
  `approve` tinyint(1) NOT NULL default '0',
  `short_place` tinyint(1) NOT NULL default '0',
  `bstick` tinyint(1) NOT NULL default '0',
  `main` tinyint(1) NOT NULL default '0',
  `category` VARCHAR(255) NOT NULL default '',
  `grouplevel` varchar(100) NOT NULL default 'all',
  `start` varchar(15) NOT NULL default '',
  `end` varchar(15) NOT NULL default '',
  `fpage` tinyint(1) NOT NULL default '0',
  `innews` tinyint(1) NOT NULL default '0',
  `devicelevel` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_rss";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_rss (
  `id` smallint(5) NOT NULL auto_increment,
  `url` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `allow_main` tinyint(1) NOT NULL default '0',
  `allow_rating` tinyint(1) NOT NULL default '0',
  `allow_comm` tinyint(1) NOT NULL default '0',
  `text_type` tinyint(1) NOT NULL default '0',
  `date` tinyint(1) NOT NULL default '0',
  `search` text NOT NULL,
  `max_news` tinyint(3) NOT NULL default '0',
  `cookie` text NOT NULL,
  `category` smallint(5) NOT NULL default '0',
  `lastdate` INT(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_views";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_views (
  `id` int(11) NOT NULL auto_increment,
  `news_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";


$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_rssinform";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_rssinform (
  `id` smallint(5) NOT NULL auto_increment,
  `tag` varchar(40) NOT NULL default '',
  `descr` varchar(255) NOT NULL default '',
  `category` varchar(200) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `template` varchar(40) NOT NULL default '',
  `news_max` smallint(5) NOT NULL default '0',
  `tmax` smallint(5) NOT NULL default '0',
  `dmax` smallint(5) NOT NULL default '0',
  `approve` tinyint(1) NOT NULL default '1',
  `rss_date_format` VARCHAR(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_notice";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_notice (
  `id` mediumint(8) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `notice` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_static_files";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_static_files (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `static_id` int(11) NOT NULL default '0',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  `name` varchar(200) NOT NULL default '',
  `onserver` varchar(190) NOT NULL default '',
  `dcount` int(11) NOT NULL default '0',
  `size` bigint(20) NOT NULL default '0',
  `checksum` char(32) NOT NULL default '',
  PRIMARY KEY (`id`),
  KEY `static_id` (`static_id`),
  KEY `onserver` (`onserver`),
  KEY `author` (`author`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_tags";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_tags (
  `id` INT(11) NOT NULL auto_increment,
  `news_id` INT(11) NOT NULL default '0',
  `tag` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `tag` (`tag`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_post_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_post_log (
  `id` INT(11) NOT NULL auto_increment,
  `news_id` INT(11) NOT NULL default '0',
  `expires` varchar(15) NOT NULL default '',
  `action` tinyint(1) NOT NULL default '0',
  `move_cat` VARCHAR(190) NOT NULL DEFAULT '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `expires` (`expires`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_admin_sections";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_admin_sections (
  `id` mediumint(8) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `descr` varchar(255) NOT NULL default '',
  `icon` varchar(255) NOT NULL default '',
  `allow_groups` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_subscribe";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_subscribe (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `name` varchar(40) NOT NULL default '',
  `email`  varchar(50) NOT NULL default '',
  `news_id` int(11) NOT NULL default '0',
  `hash` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `user_id` (`user_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_sendlog";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_sendlog (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user` varchar(40) NOT NULL DEFAULT '',
  `date` INT(11) unsigned NOT NULL DEFAULT '0',
  `flag` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user` (`user`),
  KEY `date` (`date`),
  KEY `flag` (`flag`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_login_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_login_log (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(40) NOT NULL DEFAULT '',
  `count` smallint(6) NOT NULL DEFAULT '0',
  `date` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `ip` (`ip`),
  KEY `date` (`date`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_mail_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_mail_log (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `mail` varchar(50) NOT NULL DEFAULT '',
  `hash` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_complaint";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_complaint (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_id` int(11) NOT NULL DEFAULT '0',
  `c_id` int(11) NOT NULL DEFAULT '0',
  `n_id` int(11) NOT NULL DEFAULT '0',
  `text` text NOT NULL,
  `from` varchar(40) NOT NULL DEFAULT '',
  `to` varchar(255) NOT NULL DEFAULT '',
  `date` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `c_id` (`c_id`),
  KEY `p_id` (`p_id`),
  KEY `n_id` (`n_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_ignore_list";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_ignore_list (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL default '0',
  `user_from` VARCHAR(40) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `user` (`user`),
  KEY `user_from` (`user_from`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_admin_logs";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_admin_logs (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL DEFAULT '',
  `date` int(11) unsigned NOT NULL DEFAULT '0',
  `ip` varchar(40) NOT NULL DEFAULT '',
  `action` int(11) NOT NULL DEFAULT '0',
  `extras` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `date` (`date`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_question";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_question (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `question` varchar(255) NOT NULL DEFAULT '',
  `answer` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_read_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_read_log (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `news_id` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `news_id` (`news_id`),
  KEY `ip` (`ip`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_spam_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_spam_log (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(40) NOT NULL DEFAULT '',
  `is_spammer` tinyint(1) NOT NULL DEFAULT '0',
  `email` varchar(50) NOT NULL DEFAULT '',
  `date` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `ip` (`ip`),
  KEY `is_spammer` (`is_spammer`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_links";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_links (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `word` varchar(255) NOT NULL DEFAULT '',
  `link` varchar(255) NOT NULL DEFAULT '',
  `only_one` tinyint(1) NOT NULL DEFAULT '0',
  `replacearea` tinyint(1) NOT NULL DEFAULT '1',
  `rcount` tinyint(3) NOT NULL DEFAULT '0',
  `targetblank` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_social_login";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_social_login (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sid` varchar(40) NOT NULL DEFAULT '',
  `uid` int(11) NOT NULL DEFAULT '0',
  `password` varchar(32) NOT NULL DEFAULT '',
  `provider` varchar(15) NOT NULL DEFAULT '',
  `wait` tinyint(1) NOT NULL DEFAULT '0',
  `waitlogin` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `sid` (`sid`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_comment_rating_log";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_comment_rating_log (
  `id` int unsigned NOT NULL auto_increment,
  `c_id` int NOT NULL default '0',
  `member` varchar(40) NOT NULL default '',
  `ip` varchar(40) NOT NULL default '',
  `rating` TINYINT(4) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`),
  KEY `c_id` (`c_id`),
  KEY `member` (`member`),
  KEY `ip` (`ip`)
  ) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_xfsearch";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_xfsearch (
  `id` INT(11) NOT NULL auto_increment,
  `news_id` INT(11) NOT NULL default '0',
  `tagname` varchar(50) NOT NULL default '',
  `tagvalue` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`),
  KEY `tagname` (`tagname`),
  KEY `tagvalue` (`tagvalue`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_comments_files";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_comments_files (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `c_id` int(10) NOT NULL default '0',
  `author` varchar(40) NOT NULL default '',
  `date` varchar(15) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY (`id`),
  KEY `c_id` (`c_id`),
  KEY `author` (`author`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_twofactor";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_twofactor (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL default '0',
  `pin` varchar(10) NOT NULL default '',
  `attempt` tinyint(1) NOT NULL DEFAULT '0',
  `date` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `pin` (`pin`),
  KEY `date` (`date`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_redirects";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_redirects (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `from` varchar(250) NOT NULL default '',
  `to` varchar(250) NOT NULL default '',
  PRIMARY KEY (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_post_pass";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_post_pass (
  `id` INT(11) NOT NULL auto_increment,
  `news_id` INT(11) NOT NULL default '0',
  `password` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `news_id` (`news_id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_metatags";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_metatags (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(250) NOT NULL default '',
  `title` varchar(200) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `keywords` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";

if (strpos($url, "//") === 0) $url = "http:".$url;
elseif (strpos($url, "/") === 0) $url = "http://".$_SERVER['HTTP_HOST'].$url;
					
$tableSchema[] = "INSERT INTO " . PREFIX . "_rssinform VALUES (1, 'dle', 'Новости с Яндекса', '0', 'https://news.yandex.ru/index.rss', 'informer', 3, 0, 200, 1, 'j F Y H:i')";

$tableSchema[] = "INSERT INTO " . PREFIX . "_usergroups VALUES (1, 'Администраторы', 'all', 1, 'all', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 50, 101, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, '{THEME}/images/icon_1.gif', 0, 1, 1, 1, 1, 1, 1, 0, 1,500,1000,1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,1,'<b><span style=\"color:red\">','</span></b>',1,1,'all', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'zip,rar,exe,doc,pdf,swf', 4096, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, '', 1, 1, 1, 3, '800x600', 300, '200x150', 1, 3, 1000, 'jpg,png,zip,pdf',1,1)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_usergroups VALUES (2, 'Главные редакторы', 'all', 1, 'all', 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 50, 101, 1, 1, 1, 0, 2, 1, 1, 1, 1, 1, 0, '{THEME}/images/icon_2.gif', 0, 1, 0, 1, 1, 1, 1, 0, 1,500,1000,1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,1,'','',1,1,'all', 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'zip,rar,exe,doc,pdf,swf', 4096, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 2, 0, 0, 2, '', 1, 1, 1, 3, '800x600', 300, '200x150', 1, 3, 1000, 'jpg,png,zip,pdf',1,1)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_usergroups VALUES (3, 'Журналисты', 'all', 1, 'all', 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 50, 101, 1, 1, 1, 0, 3, 0, 1, 1, 1, 1, 0, '{THEME}/images/icon_3.gif', 0, 1, 0, 1, 1, 1, 1, 0, 1,500,1000,1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,1,'','',1,1,'all', 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'zip,rar,exe,doc,pdf,swf', 4096, 0, 2, 1, 0, 0, 0, 0, 3, 0, 0, 3, 0, 0, 3, 0, 0, 3, '', 1, 1, 1, 3, '800x600', 300, '200x150', 0, 3, 1000, 'jpg,png,zip,pdf',1,1)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_usergroups VALUES (4, 'Посетители', 'all', 1, 'all', 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 20, 101, 1, 1, 1, 0, 4, 0, 1, 1, 1, 1, 0, '{THEME}/images/icon_4.gif', 0, 1, 0, 1, 0, 1, 1, 1, 0,500,1000,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,1,'','',1,0,'all', 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 'zip,rar,exe,doc,pdf,swf', 4096, 0, 2, 1, 0, 2, 0, 0, 4, 0, 0, 4, 0, 0, 4, 0, 0, 4, '', 0, 0, 0, 1, '800x600', 300, '200x150', 0, 3, 1000, 'jpg,png,zip,pdf',0,0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_usergroups VALUES (5, 'Гости', 'all', 0, 'all', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 5, 0, 1, 1, 1, 0, 1, '{THEME}/images/icon_5.gif', 0, 1, 0, 0, 0, 0, 1, 1, 0,1,1,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0,'','',0,0,'all', 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, '', 0, 0, 2, 1, 0, 2, 0, 0, 5, 0, 0, 5, 0, 0, 5, 0, 0, 5, '', 0, 0, 0, 1, '800x600', 300, '200x150', 0, 3, 1000, 'jpg,png,zip,pdf',0,0)";

$tableSchema[] = "INSERT INTO " . PREFIX . "_rss VALUES (1, 'https://dle-news.ru/rss.xml', 'Официальный сайт DataLife Engine', 1, 1, 1, 1, 1, '<div class=\"full-post-content row\">{get}</div><div class=\"full-post-footer ignore-select\">', 5, '', 1, 0)";

$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (1, 'reg_mail', '{%username%},\r\n\r\nЭто письмо отправлено с сайта $url\r\n\r\nВы получили это письмо, так как этот e-mail адрес был использован при регистрации на сайте. Если Вы не регистрировались на этом сайте, просто проигнорируйте это письмо и удалите его. Вы больше не получите такого письма.\r\n\r\n------------------------------------------------\r\nВаш логин и пароль на сайте:\r\n------------------------------------------------\r\n\r\nЛогин: {%username%}\r\nПароль: {%password%}\r\n\r\n------------------------------------------------\r\nИнструкция по активации\r\n------------------------------------------------\r\n\r\nБлагодарим Вас за регистрацию.\r\nМы требуем от Вас подтверждения Вашей регистрации, для проверки того, что введённый Вами e-mail адрес - реальный. Это требуется для защиты от нежелательных злоупотреблений и спама.\r\n\r\nДля активации Вашего аккаунта, зайдите по следующей ссылке:\r\n\r\n{%validationlink%}\r\n\r\nЕсли и при этих действиях ничего не получилось, возможно Ваш аккаунт удалён. В этом случае, обратитесь к Администратору, для разрешения проблемы.\r\n\r\nС уважением,\r\n\r\nАдминистрация $url.', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (2, 'feed_mail', '{%username_to%},\r\n\r\nДанное письмо вам отправил {%username_from%} с сайта $url\r\n\r\n------------------------------------------------\r\nТекст сообщения\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\nIP адрес отправителя: {%ip%}\r\nГруппа: {%group%}\r\n\r\n------------------------------------------------\r\nПомните, что администрация сайта не несет ответственности за содержание данного письма\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (3, 'lost_mail', 'Уважаемый {%username%},\r\n\r\nВы сделали запрос на получение забытого пароля на сайте $url Однако в целях безопасности все пароли хранятся в зашифрованном виде, поэтому мы не можем сообщить вам ваш старый пароль, поэтому если вы хотите сгенерировать новый пароль, зайдите по следующей ссылке: \r\n\r\n{%lostlink%}\r\n\r\nЕсли вы не делали запроса для получения пароля, то просто удалите данное письмо, ваш пароль храниться в надежном месте, и недоступен посторонним лицам.\r\n\r\nIP адрес отправителя: {%ip%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (4, 'new_news', 'Уважаемый администратор,\r\n\r\nуведомляем вас о том, что на сайт  $url была добавлена новость, которая в данный момент ожидает модерации.\r\n\r\n------------------------------------------------\r\nКраткая информация о новости\r\n------------------------------------------------\r\n\r\nАвтор: {%username%}\r\nЗаголовок новости: {%title%}\r\nКатегория: {%category%}\r\nДата добавления: {%date%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (5, 'comments', 'Уважаемый {%username_to%},\r\n\r\nуведомляем вас о том, что на сайт  $url был добавлен комментарий к новости, на которую вы были подписаны.\r\n\r\n------------------------------------------------\r\nКраткая информация о комментарии\r\n------------------------------------------------\r\n\r\nАвтор: {%username%}\r\nДата добавления: {%date%}\r\nСсылка на новость: {%link%}\r\n\r\n------------------------------------------------\r\nТекст комментария\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\n------------------------------------------------\r\n\r\nЕсли вы не хотите больше получать уведомлений о новых комментариях к данной новости, то проследуйте по данной ссылке: {%unsubscribe%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (6, 'pm', 'Уважаемый {%username%},\r\n\r\nуведомляем вас о том, что на сайте  $url вам было отправлено персональное сообщение.\r\n\r\n------------------------------------------------\r\nКраткая информация о сообщении\r\n------------------------------------------------\r\n\r\nОтправитель: {%fromusername%}\r\nДата  получения: {%date%}\r\nЗаголовок: {%title%}\r\n\r\n------------------------------------------------\r\nТекст сообщения\r\n------------------------------------------------\r\n\r\n{%text%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (7, 'wait_mail', 'Уважаемый {%username%},\r\n\r\nВы сделали запрос на обьединение  вашего аккаунта на сайте $url с аккаунтом в социальной сети {%network%}.  Однако в целях безопасности вам необходимо подтвердить данное действие по следующей ссылке: \r\n\r\n------------------------------------------------\r\n{%link%}\r\n------------------------------------------------\r\n\r\nВнимание, в случае объединения аккаунтов, ваш основной пароль на сайте будет сброшен, и если вы входили на сайт используя ваш логин и пароль, то ваш пароль будет больше не действителен.\r\n\r\nЕсли вы не делали данного запроса, то просто удалите это письмо, данные вашего аккаунта хранятся в надежном месте, и недоступны посторонним лицам.\r\n\r\nIP адрес отправителя: {%ip%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (8, 'newsletter', '<html>\r\n<head>\r\n<title>{%title%}</title>\r\n<meta content=\"text/html; charset={%charset%}\" http-equiv=Content-Type>\r\n<style type=\"text/css\">\r\nhtml,body{\r\n    font-family: Verdana;\r\n    word-spacing: 0.1em;\r\n    letter-spacing: 0;\r\n    line-height: 1.5em;\r\n    font-size: 11px;\r\n}\r\n\r\np {\r\n	margin:0px;\r\n	padding: 0px;\r\n}\r\n\r\na:active,\r\na:visited,\r\na:link {\r\n	color: #4b719e;\r\n	text-decoration:none;\r\n}\r\n\r\na:hover {\r\n	color: #4b719e;\r\n	text-decoration: underline;\r\n}\r\n</style>\r\n</head>\r\n<body>\r\n{%content%}\r\n</body>\r\n</html>', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_email values (9, 'twofactor', '{%username%},\r\n\r\nЭто письмо отправлено с сайта $url\r\n\r\nВы получили это письмо, так как для вашего аккаунта включена двухфакторная авторизация. Для авторизации на сайте вам необходимо ввести полученный вами пин-код.\r\n\r\n------------------------------------------------\r\nПин-код:\r\n------------------------------------------------\r\n\r\n{%pin%}\r\n\r\n------------------------------------------------\r\nЕсли Вы не авторизовывались на нашем сайте, то ваш пароль известен посторонним лицам. Вам нужно незамедлительно зайти на сайт под своим логином и паролем, и в своем профиле изменить свой пароль.\r\n\r\nIP пользователя который ввел пароль: {%ip%}\r\n\r\nС уважением,\r\n\r\nАдминистрация $url', 0)";

// Admin Section [SeoPirat]
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (2, 'pkinopoisk', 'Парсер КиноПоиск (PKinoPoisk)', 'Импорт информации с сайта КиноПоиск (настройки)', 'pkinopoisk.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (6, 'catface', 'CatFace - SEO оптимизация категорий', 'Модуль позволяет прикрепить к категориям и главной странице описание и заголовок, а так же регулировать их вывод на разных страницах', 'catface.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (22, 'moonserials', 'MoonSerials', 'модуль для автоматизации работы с сериалами на сервисе moonwalk.cc', 'hdlight.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (28, 'kinopoisk_dle', 'Parser Kinopoisk for DLE v6.1', 'Настройка парсера', 'kinopoisk_dle.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (23, 'ufmoon', 'ufMoon', 'обновление качества фильмов с moonwalk.cc', 'ufmoon.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (17, 'hdlight', 'HD Light', 'Автор: Timphenix Development [ timphenix@ya.ru ]', 'hdlight.png', '1')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_admin_sections (id,name,title,descr,icon,allow_groups) values (26, 'iprem', 'iPrem 2.0', 'Список фильмов по годам и топовых премьер', 'iprem.png', '1')";

# Categories [SeoPirat]
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (1, 0, 1, 'Аниме ', 'anime', '', '', 'Фильмы аниме вы можете смотреть на баскино бесплатно без регистрации в хорошем качестве на телефоне и планшете  android ', 'Фильмы аниме, аниме на баскино, баскино смотреть аниме, аниме фильмы, аниме сериалы', '', '', 0, '', '', 'Фильмы аниме новинки смотреть онлайн бесплатно в качестве hd 720 ', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (2, 0, 1, 'Биография ', 'biografiya', '', 'Baskino', 'Фильмы о биографии смотреть онлайн бесплатно в хорошем качестве hd 720 бесплатно, без регистрации на сайте Баскино ', 'Баскино биографии, биографии смотреть онлайн, биографии лучшие фильмы', 'rating', '', 0, '', '', 'Биография онлайн, смотреть бесплатно лучшие биографические фильмы в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (3, 0, 1, 'Боевики', 'boevik', '', '', 'Боевики смотреть на баскино в качестве hd 720 бесплатно без регистрации на телефоне и планшете.', 'боевики баскино, боевкик смотреть онлайн, лучшие боевики смотреть бесплатно', '', '', 0, '', '', 'Боевики смотреть онлайн баскино список лучших фильмов которые можно посмотреть бесплатно ', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (4, 0, 1, 'Вестерны', 'vestern', '', '', 'Вестерн смотреть онлайн на баскино бесплатно в хорошем качестве hd 720 без регистрации на телефоне и планшете.', 'вестерны онлайн, вестерны баскино, вестерны смотреть онлайн', '', '', 0, '', '', 'Вестерн смотреть онлайн список лучших фильмов новинок на баскино бесплатно в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (5, 0, 1, 'Военные', 'voennyy', '', '', 'Военные фильмы Баскино список лучших смотреть онлайн бесплатно на телефоне и планшете без регистрации и смс', 'военные, военные фильмы, военные 2016, смотреть военные, военные онлайн', '', '', 0, '', '', 'Лучшие военные фильмы онлайн, смотреть новые военные фильмы бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (6, 0, 1, 'Детективы', 'detektiv', '', '', 'Детективы на баскино, рекомендуем смотреть бесплатно последние детективные фильмы онлайн в хорошем качестве', 'детективы онлайн, смотреть онлайн детективы, детективы баскино', '', '', 0, '', '', 'Детективы онлайн, смотреть бесплатно лучшие детективные фильмы в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (7, 0, 1, 'Детские', 'detskiy', '', '', 'Фильмы для детей смотреть онлайн Баскино  в хорошем качестве бесплатно  на ваших телефонах и смартфонах.', 'Фильмы для детей смотреть, фильмы про детей онлайн, баскино для детей,', '', '', 0, '', '', 'Фильмы для детей онлайн, лучшие фильмы для детей смотреть онлайн бесплатно в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (8, 0, 1, 'Документальные', 'dokumentalnyy', '', '', 'Документальные фильмы смотреть онлайн Баскино - рекомендуем смотреть бесплатно Документальные фильмы онлайн в хорошем качестве', 'документальное фильмы смотреть, Документальные фильмы бесплатно в хорошем качестве, лучшее Документальное кино', '', '', 0, '', '', 'Документальные фильмы онлайн, смотреть бесплатно лучшее документальное Кино', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (9, 0, 1, 'Драмы', 'drama', '', '', 'Драма смотреть онлайн Баскино - Baskino бесплатно в хорошем качестве HD 720 ', 'Драмы бесплатно в хорошем качестве, лучшие фильмы Драмы на баскино', '', '', 0, '', '', 'Драмы онлайн, смотреть бесплатно лучшие драмы в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (10, 0, 1, 'Игры', 'igra', '', '', 'Игра смотреть онлайн Баскино - Baskino бесплатно в хорошем качестве HD 720 ', 'фильмы игра, фильмы о игре смотреть онлайн, игра баскино', '', '', 0, '', '', 'Фильмы Игра смотреть онлайн Баскино в хорошем качестве hd 720  новинки фильмов о игре смотреть онлайн', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (11, 0, 1, 'Исторические', 'istoriya', '', '', 'В данной категории смотрите онлайн историческое кино бесплатно в хорошем качестве, лучшие Исторические фильмы на баскино ', 'исторические фильмы онлайн смотреть, популярные исторические фильмы ', '', '', 0, '', '', 'Исторические фильмы онлайн, смотреть бесплатно лучшие исторические фильмы', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (12, 0, 1, 'Комедии', 'komediya', '', '', 'Комедии новинки онлайн Баскино  бесплатно в хорошем качестве hd 720  без регистрации и смс', 'комедии смотреть онлайн, комедии на баскино онлайн, лучшие комедии онлайн', '', '', 0, '', '', 'Комедии онлайн, смотреть бесплатно лучшие комедийные фильмы в хорошем качестве', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (13, 0, 1, 'Криминал', 'kriminal', '', '', 'Криминал баскино список лучших фильмов которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на вашем телефоне и планшете без регистрации', 'криминал фильмы, смотреть криминал, русский криминал, криминал онлайн, боевик криминал, смотреть онлайн криминал', '', '', 0, '', '', 'Криминальные фильмы онлайн, смотреть бесплатно лучшее криминальное кино', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (14, 0, 1, 'Мелодрамы', 'melodrama', '', '', 'Мелодрамы фильмы Баскино список лучших, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на телефоне и планшете', 'мелодрамы, русские мелодрамы, смотреть мелодрамы, мелодрамы онлайн, мелодрамы смотреть онлайн', '', '', 0, '', '', 'Лучшие и новые мелодрамы онлайн, фильмы мелодрамы смотреть бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (15, 0, 1, 'Мультфильмы', 'multfilm', '', '', 'Мультфильмы смотреть на Баскино список лучших, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на телефоне и планшете', 'мультфильмы, мультфильмы онлайн,смотреть мультфильмы,смотреть онлайн мультфильмы,бесплатные мультфильмы', '', '', 0, '', '', 'Мультфильмы онлайн бесплатно, смотреть лучшие и новые мультфильмы в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (16, 0, 1, 'Приключения', 'priklyucheniya', '', '', 'Приключения смотреть Баскино список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 на вашем телефоне бесплатно и без регистрации', 'приключения, смотреть приключения, приключения онлайн, приключение смотреть онлайн, приключения бесплатно', '', '', 0, '', '', 'Приключенческие фильмы онлайн, смотреть лучшие и новые фильмы приключения бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (17, 0, 1, 'Реальное ТВ', 'realnoe-tv', '', '', 'Реально ТВ Баскино список лучших передач, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно и без регистрации на вашем телефоне и планшете', 'передачи онлайн, смотреть онлайн передачи, передачи онлайн бесплатно, передачи онлайн смотреть бесплатно, первая передача онлайн', '', '', 0, '', '', 'Смотреть лучшие передачи онлайн, новые тв передачи бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (18, 0, 1, 'Семейные', 'semeynyy', '', '', 'Семейные фильмы на баскино список лучших фильмов, которые уже можно посмотреть в хорошем качестве бесплатно и без регистрации на вашем телефоне и планшете', 'смотреть семейные,семейные онлайн, семейные фильмы, семейные смотреть онлайн', '', '', 0, '', '', 'Семейные фильмы онлайн, смотреть новые и лучшие фильмы для семьи бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (19, 0, 1, 'Спортивные', 'sport', '', '', 'Спортивные фильмы на Баскино список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на вашем телефоне и планшете бесплатно и без регистрации', 'спортивные фильмы, смотреть спортивные фильмы, онлайн фильмы спортивные, фильмы спортивные смотреть онлайн, спортивные фильмы онлайн бесплатно', '', '', 0, '', '', 'Спортивное кино онлайн, смотреть бесплатно лучшие спортивные фильмы', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (20, 0, 1, 'ТВ-Шоу', 'tv-shou', '', '', 'ТВ ШОУ смотреть на Баскино список лучших программ, которые можно посмотреть в хорошем качестве бесплатно и без регистрации на вашем телефоне', 'передачи онлайн, смотреть онлайн передачи, передачи онлайн бесплатно, передачи онлайн смотреть бесплатно, первая передача онлайн', '', '', 0, '', '', 'Смотреть лучшие ТВ шоу онлайн, новые тв передачи бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (21, 0, 1, 'Триллеры', 'triller', '', '', 'Триллер смотреть Баскино список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на телефоне и планшете', 'триллеры, смотреть триллеры, лучшие триллеры, триллеры онлайн, лучше триллеры, триллер смотреть онлайн', '', '', 0, '', '', 'Лучшие триллеры онлайн, смотреть новые фильмы триллеры бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (22, 0, 1, 'Ужасы', 'uzhasy', '', '', 'Ужасы смотреть ГидОнлайн список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно на вашем телефоне', 'ужасы, фильмы ужасов,смотреть ужасы,ужасы онлайн, ужасы онлайн смотреть', '', '', 0, '', '', 'Смотреть фильмы ужасов онлайн, лучшие и новые ужасы бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (23, 0, 1, 'Фантастические', 'fantastika', '', '', 'Фантастика смотреть БасКино список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно и без регистрации', 'фантастика онлайн, смотреть фантастику, фильмы фантастика, фантастика смотреть онлайн, бесплатно фантастика', '', '', 0, '', '', 'Фантастика онлайн, смотреть лучшие и новые фантастические фильмы бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (24, 0, 1, 'Фэнтези', 'fentezi', '', '', 'Фэнтези смотреть Баскино список лучших фильмов, которые уже можно посмотреть в хорошем качестве hd 720 бесплатно и без регистрации', 'фэнтези онлайн, фэнтези фильмы, смотреть фэнтези, фэнтези бесплатно, фэнтези смотреть онлайн', '', '', 0, '', '', 'Лучшие фильмы фэнтези онлайн, смотреть новые фильмы фэнтези бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (25, 0, 1, 'Сериалы', 'serial', '', '', 'Сериалы смотреть баскино бесплатно список фильмов которые уже можно посмотреть в хорошем качестве все сезоны на телефоне и планшете без регистрации', 'сериалы, смотреть сериалы, сериалы онлайн смотреть, сериалы онлайн, сезон сериал', '', '', 0, '', '', 'Лучшие и новые сериалы онлайн, смотреть сериалы бесплатно в хорошем качестве hd', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (26, 25, 1, 'Русские сериалы', 'russkie-serialy', '', '', 'Русские сериалы на баскино список которых уже можно посмотреть бесплатно на вашем телефоне или планшете', 'Русские сериалы, отечественные сериалы, русские сериалы на ТНТ, сериалы на СТС, русские сериалы смотреть онлайн', '', '', 0, '', '', 'Русские сериалы Баскино смотреть список лучших бесплатно в хорошем качестве  hd 720', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (27, 25, 1, 'Зарубежные сериалы', 'zarubezhnye-serialy', '', '', 'Зарубежные сериалы список которых уже можно посмотреть в хорошем качестве hd 720 бесплатно на нашем сайте баскино', 'Зарубежные сериалы, зарубежные сериалы смотреть онлайн, зарубежные сериалы смотреть на русском языке', '', '', 0, '', '', 'Зарубежные сериалы на русском смотреть Баскино бесплатно все серии подряд', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (28, 0, 1, 'Музыкальные', 'muzyka', '', '', 'Фильмы о музыке смотреть на баскино список лучших фильмов в качестве hd 720 бесплатно на вашем телефоне или планшете без регистрации', 'Фильмы о музыке, музыкальные фильмы, лучшие фильмы о музыке, фильмы о музыке смотреть онлайн', '', '', 0, '', '', 'Фильмы о музыке смотреть онлайн Баскино бесплатно в хорошем качестве hd 720', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (29, 0, 1, 'Новинки', 'novinki', '', '', 'Фильмы новинки 2017 2016 года смотреть бесплатно на сайте баскино можно в хорошем качестве hd 720, без регистрации  ', 'новинки фильмов, фильмы новинки, новинки баскино, фильмы новинки онлайн', '', '', 0, '', '', 'Фильмы Новинки баскино смотреть онлайн бесплатно в хорошем качестве hd 720', 0, 1, '', 0)";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category (id, parentid, posi, name, alt_name, icon, skin, descr, keywords, news_sort, news_msort, news_number, short_tpl, full_tpl, metatitle, show_sub, allow_rss, fulldescr, disable_search) values (30, 0, 1, 'Трейлеры', 'treylery', '', '', '', '', '', '', 0, '', '', 'Трейлеры смотреть онлайн бесплатно в хорошем качестве', 0, 1, '', 0)";

#CategoryFace
$tableSchema[] = "INSERT INTO " . PREFIX . "_category_face (category_id, name, name_pages, description, description_pages, module_placement, show_name, show_description, name_placement, description_placement) values (1, 'Аниме смотреть онлайн', '', 'В 2030 году исследовательская экспедиция Арес 3 достигает Марса. Создав на его поверхности временную базу с искусственной средой обитания, команда астронавтов планирует в течение двух месяцев заниматься изучением красной планеты. Но по истечению восемнадцати дней на Марсе начинается очень сильная песчаная буря и группе исследователей приходится срочным образом эвакуироваться с изучаемого объекта, отказавшись от заранее намеченных планов, понимая, что в противном случае они могут навсегда остаться на безлюдной планете. Во время спешной эвакуации, повредив свои приборы, в начавшейся буре пропадает ученый-ботаник Марк Уотни. Командир экипажа Мелисса Льюис, посчитав его погибшим, принимает решение срочным образом покинуть Марс, чтобы спасти остальных членов команды.\nЧудом выживший во время марсианского шторма Уотни возвращается на временную базу и выясняет, что связаться с Землей не представляется возможным. Оставшись в полном одиночестве на безжизненной планете, понимая, что следующая экспедиция на Марс запланирована через четыре года, а запасов пищи ему хватит максимум на один, нашему герою предстоит решить непростую задачу: попытаться наладить контакт с Землей и, несмотря ни на что, выжить в сложившейся ситуации, используя все свои знания и навыки, чтобы, в один прекрасный момент, снова ступить на поверхность родной планеты.', '', 'all_pages', 'show', 'show', 'all_pages', 'first_page')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_category_face (category_id, name, name_pages, description, description_pages, module_placement, show_name, show_description, name_placement, description_placement) values (2, 'Биография онлайн', '', '<p>Фильмы биографии всегда привлекают внимание зрителей и в этом нет ничего удивительного, ведь каждый  понимает, что в основе каждого такого фильма лежит реальная история, которая происходила с реальными людьми. Несмотря на то, что режиссеры порой добавляют что-то от себя в эти фильмы они не становятся хуже, наоборот, они лучше доносят до нас те события, которые происходили с этими людьми и помогают прочувствовать ту атмосферу, которую переживали реальные герои. Смотреть такие киноленты всегда очень увлекательно, ведь на протяжении всего просмотра вас не оставляет мысль о том, что это не выдуманная история. Данные фильмы всегда тепло встречаются кинокритиками и собирают большое количество наград. В мире жило очень много интересных людей, о жизни которых мы порой узнаем лишь из книг, но возможность<strong> смотреть фильмы биографии в хорошем качестве позволяет более детально узнать об их личностях, либо событиях, которые с ними происходили.</strong></p><br><p>Если же вы все таки надумали смотреть фильмы биографии бесплатно, то вы попали именно туда, куда надо. Наш сайт предлагает вам широкий выбор отличных фильмов данного жанра, причем вам не надо регистрироваться, просто запускаете видео и смотрите. Ведь не всегда тот или иной фильм показывают в кинотеатре, да и возможность сходить в него тоже не всегда имеется, именно поэтому мы рекомендуем вам посмотреть их прямо с нашего сайта и вам не придется выходить из дома. Все фильмы исключительно в хорошем качестве и с отличным переводом, который вас не разочарует. Если же вы не нашли фильм биографию, который хотели посмотреть - вы всегда можете оставить заявку через стол заказов и мы обязательно добавим его в нашу коллекцию. Приятного вам просмотра!</p>', '<p>Фильмы биографии всегда привлекают внимание зрителей и в этом нет ничего удивительного, ведь каждый  понимает, что в основе каждого такого фильма лежит реальная история, которая происходила с реальными людьми. Несмотря на то, что режиссеры порой добавляют что-то от себя в эти фильмы они не становятся хуже, наоборот, они лучше доносят до нас те события, которые происходили с этими людьми и помогают прочувствовать ту атмосферу, которую переживали реальные герои. Смотреть такие киноленты всегда очень увлекательно, ведь на протяжении всего просмотра вас не оставляет мысль о том, что это не выдуманная история. Данные фильмы всегда тепло встречаются кинокритиками и собирают большое количество наград. В мире жило очень много интересных людей, о жизни которых мы порой узнаем лишь из книг, но возможность<strong> смотреть фильмы биографии в хорошем качестве позволяет более детально узнать об их личностях, либо событиях, которые с ними происходили.</strong></p><br><p>Если же вы все таки надумали смотреть фильмы биографии бесплатно, то вы попали именно туда, куда надо. Наш сайт предлагает вам широкий выбор отличных фильмов данного жанра, причем вам не надо регистрироваться, просто запускаете видео и смотрите. Ведь не всегда тот или иной фильм показывают в кинотеатре, да и возможность сходить в него тоже не всегда имеется, именно поэтому мы рекомендуем вам посмотреть их прямо с нашего сайта и вам не придется выходить из дома. Все фильмы исключительно в хорошем качестве и с отличным переводом, который вас не разочарует. Если же вы не нашли фильм биографию, который хотели посмотреть - вы всегда можете оставить заявку через стол заказов и мы обязательно добавим его в нашу коллекцию. Приятного вам просмотра!</p>', 'all_pages', 'show', 'show', 'all_pages', 'first_page')";

#HDLIGHT_VOICE [SeoPirat]
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (1, 52, '2x2', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (2, 16, 'Agatha Studdio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (3, 7, 'Alexfilm', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (4, 89, 'AlFair Studio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (5, 40, 'Alt Pro', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (6, 88, 'AMC', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (7, 32, 'Amedia', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (8, 36, 'Ancord', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (9, 49, 'AniDUB', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (10, 48, 'AniLibria', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (11, 102, 'AvePremier', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (12, 34, 'AXN Sci-fi', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (13, 9, 'BaibaKo', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (14, 17, 'Coldfilm', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (15, 87, 'CTC', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (16, 73, 'datynet', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (17, 72, 'den904', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (18, 64, 'Discovery', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (19, 42, 'Diva Universal', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (20, 60, 'DreamRecords', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (21, 22, 'Filiza Studio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (22, 28, 'Flux-Team', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (23, 99, 'FocusStudio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (24, 18, 'Fox', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (25, 41, 'F-TRAIN', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (26, 81, 'Gears Media', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (27, 61, 'GladiolusTV', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (28, 30, 'GREEN TEA', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (29, 8, 'HamsterStudio ', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (30, 80, 'HTB', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (31, 57, 'IdeaFilm', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (32, 12, 'Jaskier', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (33, 24, 'Jetvis Studio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (34, 13, 'Jimmy J.', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (35, 100, 'JWA Project', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (36, 98, 'Levelin', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (37, 79, 'Lord32x', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (38, 2, 'LostFilm', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (39, 26, 'Lw13pro', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (40, 51, 'MC Entertainment', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (41, 75, 'napaBo3uk', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (42, 58, 'Narkom Pro', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (43, 3, 'Newstudio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (44, 59, 'Nice-Media', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (45, 4, 'Novafilm', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (46, 78, 'Novamedia', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (47, 96, 'OMSKBIRD records', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (48, 97, 'Onibaku', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (49, 10, 'Ozz', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (50, 90, 'Paramount Comedy', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (51, 74, 'PashaUp', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (52, 63, 'Prichudiki', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (53, 19, 'ProjektorShow', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (54, 77, 'R.A.I.M', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (55, 94, 'SDI Media', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (56, 47, 'SET Russia', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (57, 95, 'SHIZA Project', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (58, 43, 'Sony Sci-Fi', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (59, 85, 'Sony Turbo', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (60, 101, 'STEPonee', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (61, 93, 'Sunshine Studio', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (62, 15, 'To4ka', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (63, 86, 'Tycoon', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (64, 45, 'Universal Russia', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (65, 29, 'Victory-Films', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (66, 14, 'ViruseProject', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (67, 62, 'VO-production', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (68, 37, 'xaros', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (69, 71, 'xixidok', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (70, 68, 'Zamez', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (71, 53, 'АРК ТВ', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (72, 70, 'Гаврилов', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (73, 82, 'Гоблин', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (74, 25, 'Дасевич', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (75, 66, 'двухголосый закадровый', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (76, 21, 'Дубляж', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (77, 76, 'Есарев', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (78, 69, 'Живов', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (79, 92, 'Кравец', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (80, 11, 'Кубик в Кубе', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (81, 5, 'Кураж-бамбей', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (82, 27, 'Матвеев', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (83, 67, 'многоголосый закадровый', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (84, 50, 'Невафильм', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (85, 44, 'Несмертельное оружие', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (86, 65, 'одноголосый закадровый', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (87, 83, 'Первый канал', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (88, 6, 'Сербин', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (89, 56, 'Студия Райдо', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (90, 20, 'Субтитры', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (91, 23, 'Сыендук', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (92, 46, 'Шадинский', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (93, 103, 'Украинский', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (94, 105, 'Animedia', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (95, 104, 'KANSAI', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (96, 108, 'StudioBand', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (97, 107, 'Субтитры PhysKids', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (98, 106, 'ТВ-3', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (99, 110, 'D1', 0, 0)";
$tableSchema[] = "INSERT INTO " . PREFIX ."_hdlight_voice (id, voice_id, voice_name, film_priority, serial_priority) values (100, 109, 'Good People', 0, 0)";

#Images [SeoPirat]
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (1, '2017-07/1499384389_poster-474.jpg|||2017-07/1499390245_poster-841700.jpg|||2017-07/1499390901_poster-674170.jpg|||2017-07/1499391131_poster-944708.jpg|||2017-07/1499391393_poster-573239.jpg|||2017-07/1499391745_poster-491724.jpg', 54, '$reg_username', '1499384389')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (2, '2017-08/1502630761-454052700.jpg', 58, '$reg_username', '1502630762')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (3, '2017-09/1504716018-1468589553.jpg', 60, '$reg_username', '1504716023')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (4, '2017-09/1504963703-567836309.jpg', 61, '$reg_username', '1504963704')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (5, '2017-09/1504973174-2125398923.jpg|||2017-09/1504973852-2042565987.jpg', 62, '$reg_username', '1504973174')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (6, '2017-09/1505117392-796906655.jpg|||2017-09/1505117492-1021661190.jpg|||2017-09/1505152045-543053343.jpg|||2017-09/1505152143-819939191.jpg', 63, '$reg_username', '1505117392')";
$tableSchema[] = "INSERT INTO " . PREFIX ."_images (id, images, news_id, author, date) values (7, '2017-09/1505319485-1150968976.jpg', 64, '$reg_username', '1505319486')";


$tableSchema[] = "INSERT INTO " . PREFIX . "_banners (banner_tag, descr, code, approve, short_place, bstick, main, category) values ('header', 'Верхний баннер', '<div align=\"center\"><a href=\"https://dle-news.ru/\" target=\"_blank\"><img src=\"{$url}templates/Default/images/_banner_.gif\" style=\"border: none;\" alt=\"\" /></a></div>', 1, 0, 0, 0, 0)";

$add_time = time();
$thistime = date ("Y-m-d H:i:s", $add_time);

$tableSchema[] = "INSERT INTO " . PREFIX . "_static (`name`, `descr`, `template`, `allow_br`, `allow_template`, `grouplevel`, `tpl`, `metadescr`, `metakeys`, `views`, `template_folder`, `date`) VALUES ('dle-rules-page', 'Общие правила на сайте', '<b>Общие правила поведения на сайте:</b><br /><br />Начнем с того, что на сайте общаются сотни людей, разных религий и взглядов, и все они являются полноправными посетителями нашего сайта, поэтому если мы хотим чтобы это сообщество людей функционировало нам и необходимы правила. Мы настоятельно рекомендуем прочитать настоящие правила, это займет у вас всего минут пять, но сбережет нам и вам время и поможет сделать сайт более интересным и организованным.<br /><br />Начнем с того, что на нашем сайте нужно вести себя уважительно ко всем посетителям сайта. Не надо оскорблений по отношению к участникам, это всегда лишнее. Если есть претензии - обращайтесь к Админам или Модераторам (воспользуйтесь личными сообщениями). Оскорбление других посетителей считается у нас одним из самых тяжких нарушений и строго наказывается администрацией. <b>У нас строго запрещен расизм, религиозные и политические высказывания.</b> Заранее благодарим вас за понимание и за желание сделать наш сайт более вежливым и дружелюбным.<br /><br /><b>На сайте строго запрещено:</b> <br /><br />- сообщения, не относящиеся к содержанию статьи или к контексту обсуждения<br />- оскорбление и угрозы в адрес посетителей сайта<br />- в комментариях запрещаются выражения, содержащие ненормативную лексику, унижающие человеческое достоинство, разжигающие межнациональную рознь<br />- спам, а также реклама любых товаров и услуг, иных ресурсов, СМИ или событий, не относящихся к контексту обсуждения статьи<br /><br />Давайте будем уважать друг друга и сайт, на который Вы и другие читатели приходят пообщаться и высказать свои мысли. Администрация сайта оставляет за собой право удалять комментарии или часть комментариев, если они не соответствуют данным требованиям.<br /><br />При нарушении правил вам может быть дано <b>предупреждение</b>. В некоторых случаях может быть дан бан <b>без предупреждений</b>. По вопросам снятия бана писать администратору.<br /><br /><b>Оскорбление</b> администраторов или модераторов также караются <b>баном</b> - уважайте чужой труд.<br /><br /><div align=\"center\">{ACCEPT-DECLINE}</div>', 1, 1, 'all', '', 'Общие правила', 'Общие правила', 0, '', '{$add_time}')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_users (name, password, email, reg_date, lastdate, user_group, news_num, info, signature, favorites, xfields) values ('$reg_username', '$reg_password', '$reg_email', '$add_time', '$add_time', '1', '3', '', '', '', '')";
$tableSchema[] = "INSERT INTO " . PREFIX . "_vote (category, vote_num, date, title, body) VALUES ('all', '0', '$thistime', 'Оцените работу движка', 'Лучший из новостных<br />Неплохой движок<br />Устраивает ... но ...<br />Встречал и получше<br />Совсем не понравился')";


#Posts [SeoPirat] // + new fast php date function (less code fast dev.)
function dateMinus($seconds = 0) {
  $add_time = time() - $seconds;
  $thistime = date ("Y-m-d H:i:s", $add_time);
  return $thistime;
}

$post_date = dateMinus(30);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (1, '$reg_username', '$post_date', '', 'Сорок лет назад Харриет Вангер бесследно пропала на острове, принадлежащем могущественному клану Вангер. Ее тело так и не было найдено, но ее дядя убежден, что это убийство и что убийца является членом его собственной, тесно сплоченной и неблагополучной семьи. Он нанимает опального журналиста Микаэля Блумквиста и татуированную хакершу Лисбет Саландер для проведения расследования.', 'video|http://moonwalk.cc/video/f986e2b52b86641e53990f740544ace2/iframe||kp_id|491724||year|2011||origin|The Girl with the Dragon Tattoo||genre|триллер, драма, криминал, детектив||time|153 мин. / 02:33||director|Дэвид Финчер||poster|/uploads/posts/2017-07/1499391745_poster-491724.jpg||premier|2 января 2012, «WDSSPR»||quality|HDRip||actors|Дэниэл Крэйг, Руни Мара, Кристофер Пламмер, Стеллан Скарсгард, Стивен Беркофф, Робин Райт, Йорик ван Вагенинген, Джоэли Ричардсон, Джеральдин Джеймс, Горан Вишнич||popf|1', 'Девушка с татуировкой дракона 2011', 'Девушка с татуировкой дракона 2011 смотреть на телефоне и планшете бесплатно в хорошем качестве hd 720 без регистрации и без смс, а так же есть возможность скачать на высокой скорости торрент Девушка', 'Вангер, семьи, Он нанимает, опального, и неблагополучной, тесно, членом, его собственной, журналиста, сплоченной, Микаэля, Саландер, для проведения, расследования, Лисбет, хакершу, Блумквиста, и татуированную, является, и что', '6,9,13,21', 'devushka-s-tatuirovkoy-drakona-2011', 0, 1, 1, 1, 0, 1, '', '', 'Девушка с татуировкой дракона 2011 смотреть онлайн бесплатно в хорошем качестве hd 720', 0)";

$post_date = dateMinus(60);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (2, '$reg_username', '$post_date', 'К концу подходит время благоденствия, и лето, длившееся почти десятилетие, угасает. Вокруг средоточия власти Семи королевств, Железного трона, зреет заговор, и в это непростое время король решает искать поддержки у друга юности Эддарда Старка. В мире, где все - от короля до наемника - рвутся к власти, плетут интриги и готовы вонзить нож в спину, есть место и благородству, состраданию и любви. Между тем, никто не замечает пробуждение тьмы из легенд далеко на Севере - и лишь Стена защищает живых к югу от нее.', 'К концу подходит время благоденствия, и лето, длившееся почти десятилетие, угасает. Вокруг средоточия власти Семи королевств, Железного трона, зреет заговор, и в это непростое время король решает искать поддержки у друга юности Эддарда Старка. В мире, где все - от короля до наемника - рвутся к власти, плетут интриги и готовы вонзить нож в спину, есть место и благородству, состраданию и любви. Между тем, никто не замечает пробуждение тьмы из легенд далеко на Севере - и лишь Стена защищает живых к югу от нее.', 'video|http://moonwalk.cc/serial/1bea7750c5b229afdcfae94887e7a0f5/iframe||trailer|<!--dle_video_begin:https://kp.cdn.yandex.net/464963/kinopoisk.ru-Game-of-Thrones-343193.mp4--><div class=\"dlevideoplayer\" style=\"width:100%;max-width:560px;\">\n<ul data-theme=\"default\" data-preload=\"metadata\">\n<li data-title=\"kinopoisk.ru-Game-of-Thrones-343193\" data-type=\"m4v\" data-url=\"https://kp.cdn.yandex.net/464963/kinopoisk.ru-Game-of-Thrones-343193.mp4\" ></li>\n</ul>\n</div><!--dle_video_end-->||kp_id|464963||year|2011||genre|фэнтези, драма, мелодрама, приключения||country|США, Великобритания||time|55 мин.||director|Алан Тейлор, Дэвид Наттер, Алекс Грейвз||poster|/uploads/posts/2017-08/1502630761-454052700.jpg||premier|8 сентября 2011||quality|HDRip||actors|Питер Динклэйдж, Лина Хиди, Эмилия Кларк, Кит Харингтон, Николай Костер-Вальдау, Мэйси Уильямс, Софи Тернер, Айзек Хемпстед-Райт, Шон Бин, Чарльз Дэнс||serials-studios|Coldfilm||serials-season|7 сезон||serii|7 серия||serials-status|Снимается', 'Игра престолов 7 сезон 7,8,9 серия', 'Игра престолов 2011 смотреть на телефоне и планшете бесплатно на киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Игра престолов 2011 смотреть онлайн, Игра престолов 2011 смотреть онлайн на киного, Игра престолов', '9,14,16,24,25', 'igra-prestolov-7-sezon', 0, 1, 1, 1, 0, 1, '', '', 'Сериал Игра престолов 7 сезон 7,8,9 серия смотреть онлайн бесплатно ', 464963)";
$post_date = dateMinus(90);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (3, '$reg_username', '$post_date', 'Вернувшись в Алма-Ату, Моро не хочет, чтобы родители знали о его приезде, и в поисках временного пристанища вспоминает о девушке, которую он когда-то любил. Дина рада встрече, но Моро что-то настораживает в ней.<br><br>Наблюдая за ее странными знакомыми, Моро понимает, что Дина стала наркоманкой. Как спасти девушку? Моро увозит ее к морю, где Дина начинает выздоравливать. Однако после возвращения в город все начинается сначала. Моро решает расправиться с поставщиками наркотиков...', 'Вернувшись в Алма-Ату, Моро не хочет, чтобы родители знали о его приезде, и в поисках временного пристанища вспоминает о девушке, которую он когда-то любил. Дина рада встрече, но Моро что-то настораживает в ней.<br><br>Наблюдая за ее странными знакомыми, Моро понимает, что Дина стала наркоманкой. Как спасти девушку? Моро увозит ее к морю, где Дина начинает выздоравливать. Однако после возвращения в город все начинается сначала. Моро решает расправиться с поставщиками наркотиков...', 'video|http://37.220.36.15/video/e8be208073cde4b8/iframe||trailer|<!--dle_video_begin:https://kp.cdn.yandex.net/42576/kinopoisk.ru--19943.mp4--><div class=\"dlevideoplayer\" style=\"width:100%;max-width:560px;\">\n     <ul data-theme=\"default\" data-preload=\"metadata\">\n       <li data-title=\"kinopoisk.ru--19943\" data-type=\"m4v\" data-url=\"https://kp.cdn.yandex.net/42576/kinopoisk.ru--19943.mp4\" ></li>\n      </ul>\n   </div><!--dle_video_end-->||kp_id|42576||year|1988||genre|триллер, драма||country|СССР||time|81 мин. / 01:21||director|Рашид Нугманов||poster|/uploads/posts/2017-09/1504716018-1468589553.jpg||quality|CAMRip||actors|Виктор Цой, Марина Смирнова, Петр Мамонов, Александр Баширов, Архимед Искаков, Геннадий Люй, Рахимджан Абдыкадыров, Григорий Эпштейн, Александр Конкс, Райхан Канатбаев', 'Игла 1988', 'Игла 1988 смотреть на телефоне и планшете бесплатно на киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Игла 1988 смотреть онлайн, Игла 1988 смотреть онлайн на киного, Игла', '9,21', 'igla-1988', 1, 1, 1, 1, 0, 1, '', '', 'Игла 1988 смотреть онлайн бесплатно в хорошем качестве hd 720', 42576)";
$post_date = dateMinus(120);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (4, '$reg_username', '$post_date', 'В сериале «Наруто» рассказ ведётся о начинающих ниндзя, только-только окончивших академию и получивших «удостоверения» в виде повязок. Сразу же после окончания герои попадают во множество переделок и опасных ситуаций, находят друзей, встречают врагов.', 'В сериале «Наруто» рассказ ведётся о начинающих ниндзя, только-только окончивших академию и получивших «удостоверения» в виде повязок. Сразу же после окончания герои попадают во множество переделок и опасных ситуаций, находят друзей, встречают врагов.', 'video|http://moonwalk.cc/serial/92812e5fe102f867a6a4623c83b7955d/iframe||trailer|<!--dle_video_begin:https://kp.cdn.yandex.net/283290/kinopoisk.ru-Naruto-25341.flv--><div class=\"dlevideoplayer\" style=\"width:100%;max-width:560px;\">\n      <ul data-theme=\"default\" data-preload=\"metadata\">\n       <li data-title=\"kinopoisk.ru-Naruto-25341\" data-type=\"m4v\" data-url=\"https://kp.cdn.yandex.net/283290/kinopoisk.ru-Naruto-25341.flv\" ></li>\n     </ul>\n   </div><!--dle_video_end-->||kp_id|283290||year|2002||genre|аниме, мультфильм, фэнтези, боевик, триллер, комедия, приключения||country|Япония||time|22 мин.||director|Хаято Датэ, Мэри Элизабет МакГлинн||poster|/uploads/posts/2017-09/1504963703-567836309.jpg||quality|Трейлер||actors|Тони Бек, Лорен Вернен, Дзюнко Такэути, Тиэ Накамура, Нориаки Сугияма, Койти Тотика, Кадзухико Иноуэ, Сётаро Морикубо, Ёити Масукава, Масако Кацуки||serials-studios|2x2||serials-season|1 сезон||serii|220 серия||serials-status|Снимается', 'Наруто 1 сезон 220 серия', 'Наруто 2002 смотреть на телефоне и планшете бесплатно на киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Наруто 2002 смотреть онлайн, Наруто 2002 смотреть онлайн на киного, Наруто', '1,2,12,15,16,21,24,25', 'naruto-1-sezon', 0, 1, 1, 1, 0, 1, '', '', 'Наруто смотреть онлайн 1-220,221,222 серия на русском языке ', 283290)";
$post_date = dateMinus(150);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (5, '$reg_username', '$post_date', 'Посреди безжалостной пустыни в величественном саркофаге погребена дочь египетского фараона, но настанет день, и она явится в наш мир вернуть себе то, что принадлежит ей по праву. Отныне миром правят боги и монстры.', 'Посреди безжалостной пустыни в величественном саркофаге погребена дочь египетского фараона, но настанет день, и она явится в наш мир вернуть себе то, что принадлежит ей по праву. Отныне миром правят боги и монстры.', 'video|http://moonwalk.cc/video/816b4d7ca6803af4/iframe||trailer|<!--dle_video_begin:https://kp.cdn.yandex.net/677638/kinopoisk.ru-Mummy_-The-324189.mp4--><div class=\"dlevideoplayer\" style=\"width:100%;max-width:560px;\">\n      <ul data-theme=\"default\" data-preload=\"metadata\">\n       <li data-title=\"kinopoisk.ru-Mummy_-The-324189\" data-type=\"m4v\" data-url=\"https://kp.cdn.yandex.net/677638/kinopoisk.ru-Mummy_-The-324189.mp4\" ></li>\n     </ul>\n   </div><!--dle_video_end-->||kp_id|677638||year|2017||genre|фэнтези, боевик, триллер, приключения||country|США||time|110 мин. / 01:50||director|Алекс Куртцман||poster|/uploads/posts/2017-09/1504973852-2042565987.jpg||premier|8 июня 2017, «UPI»||quality|HDRip||actors|Том Круз, Рассел Кроу, Аннабелль Уоллис, София Бутелла, Джейк Джонсон, Кортни Б. Вэнс, Марван Кензари, Саймон Атертон, Стивен Томпсон, Джеймс Арама||skoro|1', 'Мумия 2017', 'Мумия 2017 смотреть на телефоне и планшете бесплатно на киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Мумия 2017 смотреть онлайн, Мумия 2017 смотреть онлайн на киного, Мумия', '2,16,21,24', 'mumiya-2017', 0, 1, 1, 1, 0, 1, '', '', 'Мумия 2017 смотреть онлайн бесплатно в хорошем качестве hd 720', 677638)";
$post_date = dateMinus(150);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (6, '$reg_username', '$post_date', 'Марсианская миссия «Арес-3» в процессе работы была вынуждена экстренно покинуть планету из-за надвигающейся песчаной бури. Инженер и биолог Марк Уотни получил повреждение скафандра во время песчаной бури. Сотрудники миссии, посчитав его погибшим, эвакуировались с планеты, оставив Марка одного.<br><br>Очнувшись, Уотни обнаруживает, что связь с Землёй отсутствует, но при этом полностью функционирует жилой модуль. Главный герой начинает искать способ продержаться на имеющихся запасах еды, витаминов, воды и воздуха ещё 4 года до прилёта следующей миссии «Арес-4».', 'Марсианская миссия «Арес-3» в процессе работы была вынуждена экстренно покинуть планету из-за надвигающейся песчаной бури. Инженер и биолог Марк Уотни получил повреждение скафандра во время песчаной бури. Сотрудники миссии, посчитав его погибшим, эвакуировались с планеты, оставив Марка одного.<br><br>Очнувшись, Уотни обнаруживает, что связь с Землёй отсутствует, но при этом полностью функционирует жилой модуль. Главный герой начинает искать способ продержаться на имеющихся запасах еды, витаминов, воды и воздуха ещё 4 года до прилёта следующей миссии «Арес-4».', 'video|http://moonwalk.cc/video/556783da83bd0aa1/iframe||kp_id|841700||year|2015||origin|The Martian||genre|фантастика, приключения||country|США, Великобритания||time|144 мин. / 02:24||director|Ридли Скотт||poster|/uploads/posts/2017-09/1505152143-819939191.jpg||premier|8 октября 2015, «Двадцатый Век Фокс СНГ» 3D||quality|HDRip||actors|Мэтт Дэймон, Джессика Честейн, Чиветель Эджиофор, Кристен Уиг, Джефф Дэниелс, Майкл Пенья, Шон Бин, Кейт Мара, Себастьян Стэн, Аксель Хенни||popf|1', 'Марсианин 2015', 'Марсианин 2015 смотреть на телефоне и планшете бесплатно на Киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Марсианин 2015 смотреть онлайн в качестве hd 720 на телефоне и планшете, Марсианин 2015 смотреть онлайн полный фильм Киного', '2,3', 'marsianin-2015', 0, 1, 1, 1, 0, 1, '', '', 'Марсианин 2015 смотреть фильм онлайн бесплатно в хорошем качестве hd 720', 841700)";
$post_date = dateMinus(180);
$tableSchema[] = "INSERT INTO " . PREFIX . "_post (id, autor, date, short_story, full_story, xfields, title, descr, keywords, category, alt_name, comm_num, allow_comm, allow_main, approve, fixed, allow_br, symbol, tags, metatitle, kp_id_movie) values (7, '$reg_username', '$post_date', 'Джим Беннетт - рисковый парень. Днем он - гениальный писатель и отличный преподаватель, ночью - заядлый игрок. Он глубоко увяз в мире, где закон - пустой звук, и однажды ставит на кон все, включая собственную жизнь. Те, кому он должен, опасны, а помочь ему может только тот, кто еще опаснее.<br><br>Достоин ли второго шанса человек, проигравший самого себя? А, если да, то - во сколько это ему обойдется?', 'Джим Беннетт - рисковый парень. Днем он - гениальный писатель и отличный преподаватель, ночью - заядлый игрок. Он глубоко увяз в мире, где закон - пустой звук, и однажды ставит на кон все, включая собственную жизнь. Те, кому он должен, опасны, а помочь ему может только тот, кто еще опаснее.<br><br>Достоин ли второго шанса человек, проигравший самого себя? А, если да, то - во сколько это ему обойдется?', 'video|http://moonwalk.cc/video/f5457ebd01fb362a/iframe||kp_id|614227||year|2014||origin|The Gambler||genre|триллер, драма, криминал||country|США||time|111 мин. / 01:51||director|Руперт Уайатт||poster|/uploads/posts/2017-09/1505319485-1150968976.jpg||premier|22 января 2015, «Централ Партнершип»||quality|HDRip||actors|Марк Уолберг, Джон Гудман, Бри Ларсон, Майкл Кеннет Уильямс, Джессика Лэнг, Энтони Келли, Элвин Инг, Доменик Ломбардоззи, Эмори Коэн, Ричард Шифф||popf|1', 'Игрок 2014', 'Игрок 2014 смотреть на телефоне и планшете бесплатно на Киного фильм в хорошем качестве hd 720 без регистрации и смс', 'Игрок 2014 смотреть онлайн в качестве hd 720 на телефоне и планшете, Игрок 2014 смотреть онлайн полный фильм Киного', '13,21', 'igrok-2014', 0, 1, 1, 1, 0, 1, '', '', 'Игрок 2014 смотреть фильм онлайн бесплатно в хорошем качестве hd 720', 614227)";

$tableSchema[] = "INSERT INTO " . PREFIX . "_post_extras (eid, news_id, news_read, allow_rate, rating, vote_num, votes, view_edit, disable_index, related_ids, access, `editdate`, `editor`, `reason`, `user_id`, `disable_search`, `need_pass`) VALUES 
(1, 1, 289, 1, 10, 2, 0, 0, 0, '58', '', 1505319447, '$reg_username', '', 1, 0, 0),
(2, 2, 80, 1, 4, 1, 0, 0, 0, '61,60', '', 1502646845, '$reg_username', '', 1, 0, 0),
(3, 3, 28, 1, 5, 1, 0, 0, 0, '61,58', '', 0, '', '', 1, 0, 0),
(4, 4, 16, 1, 0, 0, 0, 0, 0, '60,58', '', 1505214866, '$reg_username', '', 1, 0, 0),
(5, 5, 24, 1, 0, 0, 0, 0, 0, '', '', 1505319394, '$reg_username', '', 1, 0, 0),
(6, 6, 43, 1, 0, 0, 0, 0, 0, '58,60', '', 1505317266, '$reg_username', '', 1, 0, 0),
(7, 7, 6, 1, 0, 0, 0, 0, 0, '61,58', '', 0, '', '', 1, 0, 0)";

$tableSchema[] = "INSERT INTO " . PREFIX . "_tags (news_id, tag) values ('1', 'по'), ('2', 'по'), ('3', 'по'), ('1', 'новости'), ('2', 'новости')";

# Additional SQL [Seopirat]
$tableSchema[] = "DROP TABLE IF EXISTS " . PREFIX . "_psp_actors";
$tableSchema[] = "CREATE TABLE " . PREFIX . "_psp_actors (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `actors_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alt_name` varchar(190) NOT NULL DEFAULT '',
  `kinopoisk_id` mediumtext NOT NULL,
  `actor` tinyint(1) NOT NULL DEFAULT '0',
  `director` tinyint(1) NOT NULL DEFAULT '0',
  `visible` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=" . $storage_engine . " DEFAULT CHARACTER SET " . COLLATE . " COLLATE " . COLLATE . "_general_ci";
$tableSchema[] = "INSERT INTO " . PREFIX . "_psp_actors (id, actors_id, name, alt_name, kinopoisk_id, actor, director, visible) values 
  (1, 1724630, 'Мелисса Моррис', 'melissa-morris', '906923', 1, 0, 0),
  (2, 1741768, 'Younan Nowzaradan', 'younan-nowzaradan', '906923', 1, 0, 0),
  (3, 4056467, 'Donald Shelton', 'donald-shelton', '906923', 1, 0, 0),
  (4, 3708350, 'Henry Foots', 'henry-foots', '906923', 1, 0, 0),
  (5, 4056468, 'Ashley Randall', 'ashley-randall', '906923', 1, 0, 0),
  (6, 4056469, 'Gordon Bacon', 'gordon-bacon', '906923', 1, 0, 0),
  (7, 4056470, 'Carol Bodenheimer', 'carol-bodenheimer', '906923', 1, 0, 0),
  (8, 1724632, 'Kenneth Brumley', 'kenneth-brumley', '906923', 1, 0, 0),
  (9, 4056471, 'Michelle Burchett', 'michelle-burchett', '906923', 1, 0, 0),
  (10, 2491708, 'Mike Dow', 'mike-dow', '906923', 1, 0, 0),
  (11, 1712063, 'Jonathan Nowzaradan', 'jonathan-nowzaradan', '906923', 0, 1, 0),
  (12, 1586952, 'Конор МакЭнэлли', 'konor-makenelli', '906923', 0, 1, 0),
  (13, 19470, 'Ален Делон', 'alen-delon', '94232', 1, 0, 0),
  (14, 199919, 'Поль Мёрисс', 'pol-meriss', '94232', 1, 0, 0),
  (15, 49019, 'Анни Жирардо', 'anni-zhirardo', '94232', 1, 0, 0),
  (16, 171633, 'Марсель Боззюффи', 'marsel-bozzyuffi', '94232', 1, 0, 0),
  (17, 183556, 'Бернар Жиродо', 'bernar-zhirodo', '94232', 1, 0, 0),
  (18, 167312, 'Ренато Сальватори', 'renato-salvatori', '94232', 1, 0, 0),
  (19, 161822, 'Морис Барье', 'moris-bare', '94232', 1, 0, 0),
  (20, 183708, 'Морис Биро', 'moris-biro', '94232', 1, 0, 0),
  (21, 945899, 'Николя Фогель', 'nikolya-fogel', '94232', 1, 0, 0),
  (22, 120766, 'Мишель Фортен', 'mishel-forten', '94232', 1, 0, 0),
  (23, 295756, 'Жозе Джованни', 'zhoze-dzhovanni', '94232', 0, 1, 0),
  (24, 2496539, 'Мирослав Гуляш', 'miroslav-gulyash', '601012', 1, 0, 0),
  (25, 3429656, 'Miroslava Jarábeková', 'miroslava-jarbekov', '601012', 1, 0, 0),
  (26, 2496540, 'Martina Kotlarova', 'martina-kotlarova', '601012', 1, 0, 0),
  (27, 3429657, 'Ivan Mirga', 'ivan-mirga', '601012', 1, 0, 0),
  (28, 2496541, 'Jan Mizigar', 'jan-mizigar', '601012', 1, 0, 0),
  (29, 1766350, 'Аттила Мокос', 'attila-mokos', '601012', 1, 0, 0),
  (30, 254665, 'Мартин Шулик', 'martin-shulik', '601012', 0, 1, 0),
  (31, 392992, 'Шандор Терхеш', 'shandor-terhesh', '127773', 1, 0, 0),
  (32, 107528, 'Ильдико Тот', 'ildiko-tot', '127773', 1, 0, 0),
  (33, 392937, 'Лилла Шарошди', 'lilla-sharoshdi', '127773', 1, 0, 0),
  (34, 392923, 'Шандор Чаньи', 'shandor-chani', '127773', 1, 0, 0),
  (35, 283413, 'Золтан Мучи', 'zoltan-muchi', '127773', 1, 0, 0),
  (36, 780373, 'Гергей Банки', 'gergey-banki', '127773', 1, 0, 0),
  (37, 392945, 'Андраш Виннаи', 'andrash-vinnai', '127773', 1, 0, 0),
  (38, 513802, 'Аннамария Ланг', 'annamariya-lang', '127773', 1, 0, 0),
  (39, 392936, 'Жольт Надь', 'zholt-nad', '127773', 1, 0, 0),
  (40, 392926, 'Аттила Галамбош', 'attila-galambosh', '127773', 1, 0, 0),
  (41, 392922, 'Виктор Бодо', 'viktor-bodo', '127773', 0, 1, 0),
  (42, 5306, 'Рики Джервэйс', 'riki-dzherveys', '395349', 1, 1, 0),
  (43, 58154, 'Эшли Дженсен', 'eshli-dzhensen', '395349', 1, 0, 0),
  (44, 1081481, 'Стивен Мерчант', 'stiven-merchant', '395349', 1, 1, 0),
  (45, 262139, 'Шон Уильямсон', 'shon-uilyamson', '395349', 1, 0, 0),
  (46, 1131564, 'Шон Пай', 'shon-pay', '395349', 1, 0, 0),
  (47, 1471966, 'Сара Мойле', 'sara-moyle', '395349', 1, 0, 0),
  (48, 121348, 'Эндрю Бакли', 'endryu-bakli', '395349', 1, 0, 0),
  (49, 1299286, 'Джэми Чэпман', 'dzhemi-chepman', '395349', 1, 0, 0),
  (50, 14497, 'Мартин Сэвадж', 'martin-sevadzh', '395349', 1, 0, 0),
  (51, 149636, 'Гай Генри', 'gay-genri', '395349', 1, 0, 0),
  (52, 290619, 'Антон Андросов', 'anton-androsov', '419520', 1, 0, 0),
  (53, 340022, 'Виктор Ильичев', 'viktor-ilichev', '419520', 1, 0, 0),
  (54, 122799, 'Михаил Кононов', 'mihail-kononov', '419520', 1, 0, 0),
  (55, 556138, 'Николай Гейко', 'nikolay-geyko', '419520', 1, 0, 0),
  (56, 1556683, 'Олег Комаров', 'oleg-komarov', '419520', 1, 0, 0),
  (57, 280989, 'Виталий Царегородцев', 'vitaliy-caregorodcev', '419520', 1, 0, 0),
  (58, 298393, 'Вячеслав Кириличев', 'vyacheslav-kirilichev', '419520', 1, 0, 0),
  (59, 4037768, 'Наталья Коркунова', 'natalya-korkunova', '419520', 1, 0, 0),
  (60, 4046775, 'Инна Коптелова', 'inna-koptelova', '419520', 1, 0, 0),
  (61, 284833, 'Юрий Катин-Ярцев', 'yuriy-katin-yarcev', '419520', 1, 0, 0),
  (62, 284282, 'Юрий Волкогон', 'yuriy-volkogon', '419520', 0, 1, 0),
  (63, 223878, 'Джаред Падалеки', 'dzhared-padaleki', '178707', 1, 0, 0),
  (64, 573946, 'Дженсен Эклс', 'dzhensen-ekls', '178707', 1, 0, 0),
  (65, 22285, 'Миша Коллинз', 'misha-kollinz', '178707', 1, 0, 0),
  (66, 227551, 'Марк Шеппард', 'mark-sheppard', '178707', 1, 0, 0),
  (67, 23417, 'Джим Бивер', 'dzhim-biver', '178707', 1, 0, 0),
  (68, 1977115, 'Рут Коннелл', 'rut-konnell', '178707', 1, 0, 0),
  (69, 13678, 'Саманта Смит', 'samanta-smit', '178707', 1, 0, 0),
  (70, 31813, 'Марк Пеллегрино', 'mark-pellegrino', '178707', 1, 0, 0),
  (71, 1220467, 'Осрик Чау', 'osrik-chau', '178707', 1, 0, 0),
  (72, 35243, 'Кертис Армстронг', 'kertis-armstrong', '178707', 1, 0, 0),
  (73, 662986, 'Филип Сгриккиа', 'filip-sgrikkia', '178707', 0, 1, 0),
  (74, 150611, 'Роберт Сингер', 'robert-singer', '178707', 0, 1, 0),
  (75, 334766, 'Ким Мэннерс', 'kim-menners', '178707', 0, 1, 0),
  (76, 25584, 'Брэд Питт', 'bred-pitt', '740644', 1, 0, 0),
  (77, 7418, 'Логан Лерман', 'logan-lerman', '740644', 1, 0, 0),
  (78, 30162, 'Шайа ЛаБаф', 'shaya-labaf', '740644', 1, 0, 0),
  (79, 28968, 'Майкл Пенья', 'maykl-penya', '740644', 1, 0, 0),
  (80, 551260, 'Джон Бернтал', 'dzhon-berntal', '740644', 1, 0, 0),
  (81, 7407, 'Джейсон Айзекс', 'dzheyson-ayzeks', '740644', 1, 0, 0),
  (82, 605817, 'Джим Пэррак', 'dzhim-perrak', '740644', 1, 0, 0),
  (83, 20929, 'Брэд Уильям Хенке', 'bred-uilyam-henke', '740644', 1, 0, 0),
  (84, 2926689, 'Кевин Вэнс', 'kevin-vens', '740644', 1, 0, 0),
  (85, 1041239, 'Завьер Сэмюэл', 'zaver-semyuel', '740644', 1, 0, 0),
  (86, 30322, 'Дэвид Эйр', 'devid-eyr', '740644', 0, 1, 0),
  (87, 267687, 'Никки Диал', 'nikki-dial', '49183', 1, 0, 0),
  (88, 54037, 'Майк Хорнер', 'mayk-horner', '49183', 1, 0, 0),
  (89, 378351, 'П.Дж. Спаркс', 'p.dzh.-sparks', '49183', 1, 0, 0),
  (90, 279316, 'Кристал Уайлдер', 'kristal-uaylder', '49183', 1, 0, 0),
  (91, 386811, 'Раша Романа', 'rasha-romana', '49183', 1, 0, 0),
  (92, 228266, 'Мими Мияджи', 'mimi-miyadzhi', '49183', 1, 0, 0),
  (93, 275171, 'Рокко Сиффреди', 'rokko-siffredi', '49183', 1, 0, 0),
  (94, 151378, 'Том Байрон', 'tom-bayron', '49183', 1, 0, 0),
  (95, 386812, 'Терри Томас', 'terri-tomas', '49183', 1, 0, 0),
  (96, 386813, 'Лори Камерон', 'lori-kameron', '49183', 1, 0, 0),
  (97, 83256, 'Пол Томас', 'pol-tomas', '49183', 0, 1, 0),
  (98, 496748, 'Збигнев Рола', 'zbignev-rola', '66275', 1, 0, 0),
  (99, 240148, 'Майя Барелковская', 'mayya-barelkovskaya', '66275', 1, 0, 0),
  (100, 271311, 'Хенрик Биста', 'henrik-bista', '66275', 1, 0, 0),
  (101, 166542, 'Збигнев Бучковский', 'zbignev-buchkovskiy', '66275', 1, 0, 0),
  (102, 1774775, 'Ивона Хоинска', 'ivona-hoinska', '66275', 1, 0, 0),
  (103, 600912, 'Малгожата Хойнацка', 'malgozhata-hoynacka', '66275', 1, 0, 0),
  (104, 495840, 'Мирослава Дубравская', 'miroslava-dubravskaya', '66275', 1, 0, 0),
  (105, 38113, 'Катажина Фигура', 'katazhina-figura', '66275', 1, 0, 0),
  (106, 125837, 'Анна Горностай', 'anna-gornostay', '66275', 1, 0, 0),
  (107, 496118, 'Ева Грабарчик', 'eva-grabarchik', '66275', 1, 0, 0),
  (108, 484850, 'Марек Котерский', 'marek-koterskiy', '66275', 0, 1, 0),
  (109, 14365, 'Эндрю Линкольн', 'endryu-linkoln', '508161', 1, 0, 0),
  (110, 1777532, 'Чендлер Риггз', 'chendler-riggz', '508161', 1, 0, 0),
  (111, 6579, 'Норман Ридус', 'norman-ridus', '508161', 1, 0, 0),
  (112, 42089, 'Мелисса Сюзанн МакБрайд', 'melissa-syuzann-makbrayd', '508161', 1, 0, 0),
  (113, 580201, 'Лорен Кохэн', 'loren-kohen', '508161', 1, 0, 0),
  (114, 1902859, 'Стивен Ян', 'stiven-yan', '508161', 1, 0, 0),
  (115, 1215604, 'Данай Джекесай Гурира', 'danay-dzhekesay-gurira', '508161', 1, 0, 0),
  (116, 1591121, 'Сонекуа Мартин-Грин', 'sonekua-martin-grin', '508161', 1, 0, 0),
  (117, 927455, 'Аланна Мастерсон', 'alanna-masterson', '508161', 1, 0, 0),
  (118, 1921915, 'Джош МакДермитт', 'dzhosh-makdermitt', '508161', 1, 0, 0),
  (119, 75861, 'Грег Никотеро', 'greg-nikotero', '508161', 0, 1, 0),
  (120, 2040, 'Эрнест Р. Дикерсон', 'ernest-r.-dikerson', '508161', 0, 1, 0),
  (121, 633728, 'Майкл Е. Сатраземис', 'maykl-e.-satrazemis', '508161', 0, 1, 0),
  (122, 17733, 'Сэм Уортингтон', 'sem-uortington', '251733', 1, 0, 0),
  (123, 10661, 'Зои Салдана', 'zoi-saldana', '251733', 1, 0, 0),
  (124, 6915, 'Сигурни Уивер', 'sigurni-uiver', '251733', 1, 0, 0),
  (125, 2807, 'Стивен Лэнг', 'stiven-leng', '251733', 1, 0, 0),
  (126, 2318, 'Мишель Родригес', 'mishel-rodriges', '251733|||894027|||666', 1, 0, 0),
  (127, 9942, 'Джованни Рибизи', 'dzhovanni-ribizi', '251733', 1, 0, 0),
  (128, 89156, 'Джоэль Мур', 'dzhoel-mur', '251733', 1, 0, 0),
  (129, 23654, 'Си Си Эйч Паундер', 'si-si-eych-paunder', '251733', 1, 0, 0),
  (130, 26959, 'Уэс Стьюди', 'ues-styudi', '251733', 1, 0, 0),
  (131, 1638, 'Лас Алонсо', 'las-alonso', '251733', 1, 0, 0),
  (132, 27977, 'Джеймс Кэмерон', 'dzheyms-kemeron', '251733|||2213', 0, 1, 0),
  (133, 5508, 'Брендан Флетчер', 'brendan-fletcher', '437414', 1, 0, 0),
  (134, 30655, 'Шон Сайпос', 'shon-saypos', '437414', 1, 0, 0),
  (135, 3287, 'Майкл Паре', 'maykl-pare', '437414', 1, 0, 0),
  (136, 8807, 'Мэтт Фрюэр', 'mett-fryuer', '437414', 1, 0, 0),
  (137, 2059, 'Линда Бойд', 'linda-boyd', '437414', 1, 0, 0),
  (138, 6286, 'Роберт Кларк', 'robert-klark', '437414', 1, 0, 0),
  (139, 583578, 'Малкольм Стюарт', 'malkolm-styuart', '437414', 1, 0, 0),
  (140, 1507802, 'Штеффен Меннекес', 'shteffen-mennekes', '437414', 1, 0, 0),
  (141, 1698331, 'Кэти Грэйс', 'keti-greys', '437414', 1, 0, 0),
  (142, 16174, 'Лори Брунетти', 'lori-brunetti', '437414', 1, 0, 0),
  (143, 32928, 'Уве Болл', 'uve-boll', '437414', 0, 1, 0),
  (144, 1413, 'Кайл МакЛоклен', 'kayl-makloklen', '843207|||84358', 1, 0, 0),
  (145, 28948, 'Шерил Ли', 'sheril-li', '843207|||84358', 1, 0, 0),
  (146, 21372, 'Кимми Робертсон', 'kimmi-robertson', '843207', 1, 0, 0),
  (147, 3131, 'Расс Тэмблин', 'rass-temblin', '843207', 1, 0, 0),
  (148, 12887, 'Медкен Эмик', 'medken-emik', '843207', 1, 0, 0),
  (149, 14951, 'Дэна Эшбрук', 'dena-eshbruk', '843207', 1, 0, 0),
  (150, 4593, 'Рэй Уайз', 'rey-uayz', '843207|||84358', 1, 0, 0),
  (151, 18760, 'Грейс Забриски', 'greys-zabriski', '843207', 1, 0, 0),
  (152, 22189, 'Эверет МакГилл', 'everet-makgill', '843207', 1, 0, 0),
  (153, 32443, 'Эми Шилз', 'emi-shilz', '843207', 1, 0, 0),
  (154, 22174, 'Дэвид Линч', 'devid-linch', '843207|||84358', 1, 1, 0),
  (155, 61510, 'Майкл Онткин', 'maykl-ontkin', '84358', 1, 0, 0),
  (156, 39227, 'Лара Флинн Бойл', 'lara-flinn-boyl', '84358', 1, 0, 0),
  (157, 67775, 'Шерилин Фенн', 'sherilin-fenn', '84358', 1, 0, 0),
  (158, 28733, 'Мигель Феррер', 'migel-ferrer', '84358', 1, 0, 0),
  (159, 45019, 'Билли Зейн', 'billi-zeyn', '84358|||2213', 1, 0, 0),
  (160, 10463, 'Хэзер Грэм', 'hezer-grem', '84358', 1, 0, 0),
  (161, 67825, 'Лесли Линка Глаттер', 'lesli-linka-glatter', '84358', 0, 1, 0),
  (162, 118645, 'Калеб Дешанель', 'kaleb-deshanel', '84358', 0, 1, 0),
  (163, 39984, 'Том Харди', 'tom-hardi', '931677', 1, 0, 0),
  (164, 8886, 'Кеннет Брана', 'kennet-brana', '931677', 1, 0, 0),
  (165, 5005, 'Киллиан Мёрфи', 'killian-merfi', '931677', 1, 0, 0),
  (166, 52280, 'Марк Райлэнс', 'mark-raylens', '931677', 1, 0, 0),
  (167, 1772158, 'Анейрин Барнард', 'aneyrin-barnard', '931677', 1, 0, 0),
  (168, 2501529, 'Гарри Стайлс', 'garri-stayls', '931677', 1, 0, 0),
  (169, 53295, 'Джеймс Д’Арси', 'dzheyms-darsi', '931677', 1, 0, 0),
  (170, 2421645, 'Барри Кеоган', 'barri-keogan', '931677', 1, 0, 0),
  (171, 2341341, 'Джек Лауден', 'dzhek-lauden', '931677', 1, 0, 0),
  (172, 1097831, 'Эллиотт Титтенсор', 'elliott-tittensor', '931677', 1, 0, 0),
  (173, 41477, 'Кристофер Нолан', 'kristofer-nolan', '931677', 0, 1, 0),
  (174, 240060, 'Чау Бель Дин', 'chau-bel-din', '14346', 1, 0, 0),
  (175, 240061, 'Уильямс Белль', 'uilyams-bell', '14346', 1, 0, 0),
  (176, 240062, 'Малик Диуф', 'malik-diuf', '14346', 1, 0, 0),
  (177, 240063, 'Ян Нутра', 'yan-nutra', '14346', 1, 0, 0),
  (178, 240064, 'Гилен Н’Губа-Бойеке', 'gilen-nguba-boyeke', '14346', 1, 0, 0),
  (179, 240059, 'Шарль Перьер', 'sharl-perer', '14346', 1, 0, 0),
  (180, 240065, 'Лоран Пьемонтези', 'loran-pemontezi', '14346', 1, 0, 0),
  (181, 240066, 'Махер Камун', 'maher-kamun', '14346', 1, 0, 0),
  (182, 5581, 'Бруно Флендер', 'bruno-flender', '14346', 1, 0, 0),
  (183, 233222, 'Амель Джемель', 'amel-dzhemel', '14346', 1, 0, 0),
  (184, 162040, 'Ариэль Зейтун', 'ariel-zeytun', '14346', 0, 1, 0),
  (185, 240057, 'Жюльен Сери', 'zhyulen-seri', '14346', 0, 1, 0),
  (186, 6458, 'Мэтт Дэймон', 'mett-deymon', '611822', 1, 0, 0),
  (187, 988159, 'Цзин Тянь', 'czin-tyan', '611822', 1, 0, 0),
  (188, 9274, 'Уиллем Дефо', 'uillem-defo', '611822', 1, 0, 0),
  (189, 83610, 'Энди Лау', 'endi-lau', '611822', 1, 0, 0),
  (190, 605204, 'Педро Паскаль', 'pedro-paskal', '611822', 1, 0, 0),
  (191, 733649, 'Чжан Ханьюй', 'chzhan-hanyuy', '611822', 1, 0, 0),
  (192, 996456, 'Лухан', 'luhan', '611822', 1, 0, 0),
  (193, 2971130, 'Кенни Линь', 'kenni-lin', '611822', 1, 0, 0),
  (194, 1164458, 'Эдди Пэн', 'eddi-pen', '611822', 1, 0, 0),
  (195, 1836694, 'Хуан Сюань', 'huan-syuan', '611822', 1, 0, 0),
  (196, 58856, 'Чжан Имоу', 'chzhan-imou', '611822', 0, 1, 0),
  (197, 11437, 'Вин Дизель', 'vin-dizel', '894027|||666', 1, 0, 0),
  (198, 31969, 'Дуэйн Джонсон', 'dueyn-dzhonson', '894027', 1, 0, 0),
  (199, 1514, 'Джейсон Стэйтем', 'dzheyson-steytem', '894027', 1, 0, 0),
  (200, 30027, 'Тайриз Гибсон', 'tayriz-gibson', '894027', 1, 0, 0),
  (201, 2016, 'Лудакрис', 'ludakris', '894027', 1, 0, 0),
  (202, 1548428, 'Натали Эммануэль', 'natali-emmanuel', '894027', 1, 0, 0),
  (203, 37652, 'Курт Рассел', 'kurt-rassel', '894027', 1, 0, 0),
  (204, 1107477, 'Скотт Иствуд', 'skott-istvud', '894027', 1, 0, 0),
  (205, 730, 'Шарлиз Терон', 'sharliz-teron', '894027', 1, 0, 0),
  (206, 30994, 'Ф. Гэри Грей', 'f.-geri-grey', '894027', 0, 1, 0),
  (207, 32087, 'Кирк Дуглас', 'kirk-duglas', '2752', 1, 0, 0),
  (208, 25081, 'Джон Кассаветис', 'dzhon-kassavetis', '2752', 1, 0, 0),
  (209, 3564, 'Кэрри Снодгресс', 'kerri-snodgress', '2752', 1, 0, 0),
  (210, 8366, 'Чарльз Дёрнинг', 'charlz-derning', '2752', 1, 0, 0),
  (211, 809, 'Эми Ирвинг', 'emi-irving', '2752', 1, 0, 0),
  (212, 145951, 'Фиона Льюис', 'fiona-lyuis', '2752', 1, 0, 0),
  (213, 1367, 'Эндрю Стивенс', 'endryu-stivens', '2752', 1, 0, 0),
  (214, 174620, 'Кэрол Ив Россен', 'kerol-iv-rossen', '2752', 1, 0, 0),
  (215, 16681, 'Рутаня Олда', 'rutanya-olda', '2752', 1, 0, 0),
  (216, 174513, 'Джойс Истон', 'dzhoys-iston', '2752', 1, 0, 0),
  (217, 7982, 'Брайан Де Пальма', 'brayan-de-palma', '2752', 0, 1, 0),
  (218, 20302, 'Том Круз', 'tom-kruz', '677638', 1, 0, 0),
  (219, 10019, 'Рассел Кроу', 'rassel-krou', '677638', 1, 0, 0),
  (220, 722699, 'Аннабелль Уоллис', 'annabell-uollis', '677638', 1, 0, 0),
  (221, 552519, 'София Бутелла', 'sofiya-butella', '677638', 1, 0, 0),
  (222, 1089330, 'Джейк Джонсон', 'dzheyk-dzhonson', '677638', 1, 0, 0),
  (223, 23803, 'Кортни Б. Вэнс', 'kortni-b.-vens', '677638', 1, 0, 0),
  (224, 1634292, 'Марван Кензари', 'marvan-kenzari', '677638', 1, 0, 0),
  (225, 98086, 'Саймон Атертон', 'saymon-aterton', '677638', 1, 0, 0),
  (226, 3064297, 'Стивен Томпсон', 'stiven-tompson', '677638', 1, 0, 0),
  (227, 4055904, 'James Arama', 'james-arama', '677638', 1, 0, 0),
  (228, 223783, 'Алекс Куртцман', 'aleks-kurtcman', '677638', 0, 1, 0),
  (229, 1047752, 'Такэси Маэда', 'takesi-maeda', '697015', 1, 0, 0),
  (230, 1631088, 'Акира Накагава', 'akira-nakagava', '697015', 1, 0, 0),
  (231, 1161418, 'Сидзука Окохира', 'sidzuka-okohira', '697015', 1, 0, 0),
  (232, 1925132, 'Юка Тэрасаки', 'yuka-terasaki', '697015', 1, 0, 0),
  (233, 4697251, 'Akemi Hayashi', 'akemi-hayashi', '697015', 0, 1, 0),
  (234, 1258557, 'Синдзи Кимура', 'sindzi-kimura', '697015', 0, 1, 0),
  (235, 4697252, 'Osamu Kobayashi', 'osamu-kobayashi', '697015', 0, 1, 0),
  (236, 1115087, 'Сатоси Хино', 'satosi-hino', '923115', 1, 0, 0),
  (237, 2804687, 'Юми Хара', 'yumi-hara', '923115', 1, 0, 0),
  (238, 639104, 'Элизабет Максвелл', 'elizabet-maksvell', '923115', 1, 0, 0),
  (239, 2768348, 'Манами Нумакура', 'manami-numakura', '923115', 1, 0, 0),
  (240, 1824135, 'Синъя Хамадзоэ', 'sinya-hamadzoe', '923115', 1, 0, 0),
  (241, 2807506, 'Сумирэ Уэсака', 'sumire-uesaka', '923115', 1, 0, 0),
  (242, 1235653, 'Эмири Като', 'emiri-kato', '923115', 1, 0, 0),
  (243, 1047638, 'Масаюки Като', 'masayuki-kato', '923115', 1, 0, 0),
  (244, 4175322, 'Сюнъити Маки', 'syuniti-maki', '923115', 1, 0, 0),
  (245, 2610066, 'Юми Утияма', 'yumi-utiyama', '923115', 1, 0, 0),
  (246, 1873736, 'Наоюки Ито', 'naoyuki-ito', '923115', 0, 1, 0),
  (247, 6245, 'Джонни Депп', 'dzhonni-depp', '575180', 1, 0, 0),
  (248, 14799, 'Хавьер Бардем', 'haver-bardem', '575180', 1, 0, 0),
  (249, 24683, 'Джеффри Раш', 'dzheffri-rash', '575180', 1, 0, 0),
  (250, 2348185, 'Брентон Туэйтс', 'brenton-tueyts', '575180', 1, 0, 0),
  (251, 1331292, 'Кая Скоделарио', 'kaya-skodelario', '575180', 1, 0, 0),
  (252, 8630, 'Кевин МакНэлли', 'kevin-maknelli', '575180', 1, 0, 0),
  (253, 535404, 'Голшифте Фарахани', 'golshifte-farahani', '575180', 1, 0, 0),
  (254, 1492, 'Дэвид Уэнэм', 'devid-uenem', '575180', 1, 0, 0),
  (255, 223, 'Стивен Грэм', 'stiven-grem', '575180', 1, 0, 0),
  (256, 30879, 'Энгус Барнетт', 'engus-barnett', '575180', 1, 0, 0),
  (257, 535911, 'Хоаким Роннинг', 'hoakim-ronning', '575180', 0, 1, 0),
  (258, 567166, 'Эспен Сандберг', 'espen-sandberg', '575180', 0, 1, 0),
  (259, 1539230, 'Никита Зверев', 'nikita-zverev', '417842', 1, 0, 0),
  (260, 1600855, 'Марина Черняева', 'marina-chernyaeva', '417842', 1, 0, 0),
  (261, 594011, 'Павел Новиков', 'pavel-novikov', '417842', 1, 0, 0),
  (262, 553560, 'Андрей Фролов', 'andrey-frolov', '417842', 1, 0, 0),
  (263, 1561930, 'Татьяна Абрамова', 'tatyana-abramova', '417842', 1, 0, 0),
  (264, 231568, 'Сергей Векслер', 'sergey-veksler', '417842', 1, 0, 0),
  (265, 1581358, 'Александр Макогон', 'aleksandr-makogon', '417842', 1, 0, 0),
  (266, 122811, 'Александр Пашутин', 'aleksandr-pashutin', '417842', 1, 0, 0),
  (267, 464130, 'Рамиль Сабитов', 'ramil-sabitov', '417842', 1, 0, 0),
  (268, 261558, 'Сергей Селин', 'sergey-selin', '417842', 1, 0, 0),
  (269, 1101290, 'Александр Черняев', 'aleksandr-chernyaev', '417842', 0, 1, 0),
  (270, 1910617, 'Дория Тилье', 'doriya-tile', '1025671', 1, 0, 0),
  (271, 1292472, 'Николя Бедос', 'nikolya-bedos', '1025671', 1, 1, 0),
  (272, 46750, 'Дени Подалидес', 'deni-podalides', '1025671', 1, 0, 0),
  (273, 1284251, 'Антуан Гуи', 'antuan-gui', '1025671', 1, 0, 0),
  (274, 57173, 'Кристиана Милле', 'kristiana-mille', '1025671', 1, 0, 0),
  (275, 19465, 'Пьер Ардити', 'per-arditi', '1025671', 1, 0, 0),
  (276, 159442, 'Забу Брайтман', 'zabu-braytman', '1025671', 1, 0, 0),
  (277, 231336, 'Жюльен Буасселье', 'zhyulen-buassele', '1025671', 1, 0, 0),
  (278, 70867, 'Жан-Пьер Лори', 'zhan-per-lori', '1025671', 1, 0, 0),
  (279, 942061, 'Жак Ланг', 'zhak-lang', '1025671', 1, 0, 0),
  (280, 439169, 'Клара Лаго', 'klara-lago', '822446', 1, 0, 0),
  (281, 774005, 'Алекс Гонсалес', 'aleks-gonsales', '822446', 1, 0, 0),
  (282, 1132096, 'Андрес Парра', 'andres-parra', '822446', 1, 0, 0),
  (283, 224228, 'Белен Руэда', 'belen-rueda', '822446', 1, 0, 0),
  (284, 906284, 'Кристина Лилли', 'kristina-lilli', '822446', 1, 0, 0),
  (285, 2493968, 'Джон Алекс Кастильо', 'dzhon-aleks-kastilo', '822446', 1, 0, 0),
  (286, 1798545, 'Фернандо Кампо', 'fernando-kampo', '822446', 1, 0, 0),
  (287, 568288, 'Сара Дерай', 'sara-deray', '822446', 1, 0, 0),
  (288, 247689, 'Пачи Сантамария', 'pachi-santamariya', '822446', 1, 0, 0),
  (289, 4717684, 'Ina Juaristi', 'ina-juaristi', '822446', 1, 0, 0),
  (290, 774615, 'Хатем Храиче', 'hatem-hraiche', '822446', 0, 1, 0),
  (291, 9213, 'Оуэн Уилсон', 'ouen-uilson', '839646', 1, 0, 0),
  (292, 1688440, 'Кристела Алонзо', 'kristela-alonzo', '839646', 1, 0, 0),
  (293, 6145, 'Крис Купер', 'kris-kuper', '839646', 1, 0, 0),
  (294, 14851, 'Нэйтан Филлион', 'neytan-fillion', '839646', 1, 0, 0),
  (295, 476619, 'Ларри-кабельщик', 'larri-kabelschik', '839646', 1, 0, 0),
  (296, 1121926, 'Арми Хаммер', 'armi-hammer', '839646', 1, 0, 0),
  (297, 964639, 'Рэй Мальоцци', 'rey-malocci', '839646', 1, 0, 0),
  (298, 25491, 'Тони Шэлуб', 'toni-shelub', '839646', 1, 0, 0),
  (299, 22527, 'Бонни Хант', 'bonni-hant', '839646', 1, 0, 0),
  (300, 81765, 'Лиа ДеЛария', 'lia-delariya', '839646', 1, 0, 0),
  (301, 1206150, 'Брайан Фи', 'brayan-fi', '839646', 0, 1, 0),
  (302, 896879, 'Халит Эргенч', 'halit-ergench', '610422', 1, 0, 0),
  (303, 1716457, 'Мерьем Узерли', 'merem-uzerli', '610422', 1, 0, 0),
  (304, 2528382, 'Селен Озтурк', 'selen-ozturk', '610422', 1, 0, 0),
  (305, 3648595, 'Гюрбей Илери', 'gyurbey-ileri', '610422', 1, 0, 0),
  (306, 3040093, 'Эзги Эюбоглу', 'ezgi-eyuboglu', '610422', 1, 0, 0),
  (307, 264015, 'Тунджел Куртиз', 'tundzhel-kurtiz', '610422', 1, 0, 0),
  (308, 482962, 'Мельтем Джумбул', 'meltem-dzhumbul', '610422', 1, 0, 0),
  (309, 2407631, 'Арас Булут Ийнемли', 'aras-bulut-iynemli', '610422', 1, 0, 0),
  (310, 4174730, 'Бурджу Озберк', 'burdzhu-ozberk', '610422', 1, 0, 0),
  (311, 2377192, 'Энгин Озтюрк', 'engin-oztyurk', '610422', 1, 0, 0),
  (312, 520980, 'Дурул Тайлан', 'durul-taylan', '610422', 0, 1, 0),
  (313, 568677, 'Ягмур Тайлан', 'yagmur-taylan', '610422', 0, 1, 0),
  (314, 958469, 'Ягыз Алп Акайдын', 'yagyz-alp-akaydyn', '610422', 0, 1, 0),
  (315, 2461035, 'Артем Быстров', 'artem-bystrov', '808639', 1, 0, 0),
  (316, 245397, 'Наталья Суркова', 'natalya-surkova', '808639', 1, 0, 0),
  (317, 231351, 'Юрий Цурило', 'yuriy-curilo', '808639', 1, 0, 0),
  (318, 273338, 'Борис Невзоров', 'boris-nevzorov', '808639', 1, 0, 0),
  (319, 1620685, 'Кирилл Полухин', 'kirill-poluhin', '808639', 1, 0, 0),
  (320, 310729, 'Александр Коршунов', 'aleksandr-korshunov', '808639', 1, 0, 0),
  (321, 251209, 'Ольга Самошина', 'olga-samoshina', '808639', 1, 0, 0),
  (322, 245617, 'Дарья Мороз', 'darya-moroz', '808639', 1, 0, 0),
  (323, 122812, 'Сергей Арцибашев', 'sergey-arcibashev', '808639', 1, 0, 0),
  (324, 251224, 'Елена Панова', 'elena-panova', '808639', 1, 0, 0),
  (325, 1762044, 'Юрий Быков', 'yuriy-bykov', '808639', 0, 1, 0),
  (326, 37859, 'Леонардо ДиКаприо', 'leonardo-dikaprio', '2213', 1, 0, 0),
  (327, 21709, 'Кейт Уинслет', 'keyt-uinslet', '2213', 1, 0, 0),
  (328, 379, 'Кэти Бейтс', 'keti-beyts', '2213', 1, 0, 0),
  (329, 22961, 'Фрэнсис Фишер', 'frensis-fisher', '2213', 1, 0, 0),
  (330, 28522, 'Глория Стюарт', 'gloriya-styuart', '2213', 1, 0, 0),
  (331, 985, 'Билл Пэкстон', 'bill-pekston', '2213', 1, 0, 0),
  (332, 13143, 'Бернард Хилл', 'bernard-hill', '2213', 1, 0, 0),
  (333, 18233, 'Дэвид Уорнер', 'devid-uorner', '2213', 1, 0, 0),
  (334, 41169, 'Виктор Гарбер', 'viktor-garber', '2213', 1, 0, 0),
  (335, 1590391, 'Сергей Светлаков', 'sergey-svetlakov', '948999', 1, 0, 0),
  (336, 3713196, 'Ольга Картункова', 'olga-kartunkova', '948999', 1, 0, 0),
  (337, 1193331, 'Сергей Бурунов', 'sergey-burunov', '948999', 1, 0, 0),
  (338, 1267063, 'Филипп Рейнхардт', 'filipp-reynhardt', '948999', 1, 0, 0),
  (339, 1770825, 'Светлана Смирнова-Марцинкевич', 'svetlana-smirnova-marcinkevich', '948999', 1, 0, 0),
  (340, 256833, 'Георгий Дронов', 'georgiy-dronov', '948999', 1, 0, 0),
  (341, 896497, 'Александр Демидов', 'aleksandr-demidov', '948999', 1, 0, 0),
  (342, 566782, 'Дмитрий Никулин', 'dmitriy-nikulin', '948999', 1, 0, 0),
  (343, 4268072, 'Наталья Паршенкова', 'natalya-parshenkova', '948999', 1, 0, 0),
  (344, 4268074, 'Магомед Муртазаалиев', 'magomed-murtazaaliev', '948999', 1, 0, 0),
  (345, 1810354, 'Александр Незлобин', 'aleksandr-nezlobin', '948999', 0, 1, 0),
  (346, 3711, 'Майкл Кейн', 'maykl-keyn', '723189', 1, 0, 0),
  (347, 6750, 'Морган Фриман', 'morgan-friman', '723189', 1, 0, 0),
  (348, 836, 'Алан Аркин', 'alan-arkin', '723189', 1, 0, 0),
  (349, 1904120, 'Ричи Мориарти', 'richi-moriarti', '723189', 1, 0, 0),
  (350, 8455, 'Джош Пэйс', 'dzhosh-peys', '723189', 1, 0, 0),
  (351, 585, 'Джон Ортис', 'dzhon-ortis', '723189', 1, 0, 0),
  (352, 3808970, 'Jorge Chapa', 'jorge-chapa', '723189', 1, 0, 0),
  (353, 40531, 'Мэтт Диллон', 'mett-dillon', '723189', 1, 0, 0),
  (354, 1141971, 'Джои Кинг', 'dzhoi-king', '723189', 1, 0, 0),
  (355, 1215694, 'Мария Диззия', 'mariya-dizziya', '723189', 1, 0, 0),
  (356, 8741, 'Зак Брафф', 'zak-braff', '723189', 0, 1, 0),
  (357, 273292, 'Дмитрий Назаров', 'dmitriy-nazarov', '840261', 1, 0, 0),
  (358, 551325, 'Дмитрий Нагиев', 'dmitriy-nagiev', '840261', 1, 0, 0),
  (359, 1909840, 'Сергей Лавыгин', 'sergey-lavygin', '840261', 1, 0, 0),
  (360, 122798, 'Олег Табаков', 'oleg-tabakov', '840261', 1, 0, 0),
  (361, 1813400, 'Анфиса Черных', 'anfisa-chernyh', '840261', 1, 0, 0),
  (362, 3691440, 'Кирилл Ковбас', 'kirill-kovbas', '840261', 1, 0, 0),
  (363, 1642559, 'Сергей Епишев', 'sergey-epishev', '840261', 1, 0, 0),
  (364, 238750, 'Михаил Тарабукин', 'mihail-tarabukin', '840261', 1, 0, 0),
  (365, 604194, 'Никита Тарасов', 'nikita-tarasov', '840261', 1, 0, 0),
  (366, 1769504, 'Михаил Башкатов', 'mihail-bashkatov', '840261', 1, 0, 0),
  (367, 2384722, 'Антон Федотов', 'anton-fedotov', '840261', 0, 1, 0),
  (368, 747671, 'Хавьер Джил', 'haver-dzhil', '108524', 1, 0, 0),
  (369, 319327, 'Дженнифер Джордан', 'dzhennifer-dzhordan', '108524', 1, 0, 0),
  (370, 188351, 'Серхио Мендисабаль', 'serhio-mendisabal', '108524', 1, 0, 0),
  (371, 445361, 'María Victoria Muela', 'mara-victoria-muela', '108524', 1, 0, 0),
  (372, 763141, 'Диана Сэндфорд', 'diana-sendford', '108524', 1, 0, 0),
  (373, 337082, 'Энрике Васкес', 'enrike-vaskes', '108524', 1, 0, 0),
  (374, 186924, 'Эльса Сабала', 'elsa-sabala', '108524', 1, 0, 0),
  (375, 446860, 'Francisco Montolío', 'francisco-montolo', '108524', 0, 1, 0),
  (376, 1906, 'Питер Динклэйдж', 'piter-dinkleydzh', '464963', 1, 0, 0),
  (377, 6578, 'Лина Хиди', 'lina-hidi', '464963', 1, 0, 0),
  (378, 1830611, 'Эмилия Кларк', 'emiliya-klark', '464963', 1, 0, 0),
  (379, 1739589, 'Кит Харингтон', 'kit-harington', '464963', 1, 0, 0),
  (380, 47200, 'Николай Костер-Вальдау', 'nikolay-koster-valdau', '464963', 1, 0, 0),
  (381, 1826849, 'Мэйси Уильямс', 'meysi-uilyams', '464963', 1, 0, 0),
  (382, 1980525, 'Софи Тернер', 'sofi-terner', '464963', 1, 0, 0),
  (383, 2235249, 'Айзек Хемпстед-Райт', 'ayzek-hempsted-rayt', '464963', 1, 0, 0),
  (384, 28092, 'Шон Бин', 'shon-bin', '464963', 1, 0, 0),
  (385, 32594, 'Чарльз Дэнс', 'charlz-dens', '464963', 1, 0, 0),
  (386, 2436, 'Алан Тейлор', 'alan-teylor', '464963', 0, 1, 0),
  (387, 64671, 'Дэвид Наттер', 'devid-natter', '464963', 0, 1, 0),
  (388, 80901, 'Алекс Грейвз', 'aleks-greyvz', '464963', 0, 1, 0),
  (389, 290123, 'Виктор Цой', 'viktor-coy', '42576', 1, 0, 0),
  (390, 294642, 'Марина Смирнова', 'marina-smirnova', '42576', 1, 0, 0),
  (391, 127898, 'Петр Мамонов', 'petr-mamonov', '42576', 1, 0, 0),
  (392, 230545, 'Александр Баширов', 'aleksandr-bashirov', '42576', 1, 0, 0),
  (393, 294643, 'Архимед Искаков', 'arhimed-iskakov', '42576', 1, 0, 0),
  (394, 290254, 'Геннадий Люй', 'gennadiy-lyuy', '42576', 1, 0, 0),
  (395, 294644, 'Рахимджан Абдыкадыров', 'rahimdzhan-abdykadyrov', '42576', 1, 0, 0),
  (396, 294179, 'Григорий Эпштейн', 'grigoriy-epshteyn', '42576', 1, 0, 0),
  (397, 594698, 'Александр Конкс', 'aleksandr-konks', '42576', 1, 0, 0),
  (398, 294645, 'Райхан Канатбаев', 'rayhan-kanatbaev', '42576', 1, 0, 0),
  (399, 294641, 'Рашид Нугманов', 'rashid-nugmanov', '42576', 0, 1, 0),
  (400, 1538746, 'Дэйн ДеХаан', 'deyn-dehaan', '689960', 1, 0, 0),
  (401, 2982053, 'Кара Делевинь', 'kara-delevin', '689960', 1, 0, 0),
  (402, 2933, 'Клайв Оуэн', 'klayv-ouen', '689960', 1, 0, 0),
  (403, 1077776, 'Рианна', 'rianna', '689960', 1, 0, 0),
  (404, 4630, 'Итан Хоук', 'itan-houk', '689960', 1, 0, 0),
  (405, 111936, 'Херби Хэнкок', 'herbi-henkok', '689960', 1, 0, 0),
  (406, 3785089, 'Крис У', 'krisu', '689960', 1, 0, 0),
  (407, 34539, 'Сэм Спруэлл', 'sem-spruell', '689960', 1, 0, 0),
  (408, 41566, 'Ален Шаба', 'alen-shaba', '689960', 1, 0, 0),
  (409, 19216, 'Рутгер Хауэр', 'rutger-hauer', '689960', 1, 0, 0),
  (410, 24505, 'Люк Бессон', 'lyuk-besson', '689960', 0, 1, 0),
  (411, 1276530, 'Тони Бек', 'toni-bek', '283290', 1, 0, 0),
  (412, 3263764, 'Лорен Вернен', 'loren-vernen', '283290', 1, 0, 0),
  (413, 767197, 'Дзюнко Такэути', 'dzyunko-takeuti', '283290', 1, 0, 0),
  (414, 1235768, 'Тиэ Накамура', 'tie-nakamura', '283290', 1, 0, 0),
  (415, 1127396, 'Нориаки Сугияма', 'noriaki-sugiyama', '283290', 1, 0, 0),
  (416, 425851, 'Койти Тотика', 'koyti-totika', '283290', 1, 0, 0),
  (417, 376419, 'Кадзухико Иноуэ', 'kadzuhiko-inoue', '283290', 1, 0, 0),
  (418, 604606, 'Сётаро Морикубо', 'setaro-morikubo', '283290', 1, 0, 0),
  (419, 1240659, 'Ёити Масукава', 'eiti-masukava', '283290', 1, 0, 0),
  (420, 99797, 'Масако Кацуки', 'masako-kacuki', '283290', 1, 0, 0),
  (421, 1235767, 'Хаято Датэ', 'hayato-date', '283290', 0, 1, 0),
  (422, 6021, 'Мэри Элизабет МакГлинн', 'meri-elizabet-makglinn', '283290', 0, 1, 0),
  (423, 6317, 'Пол Уокер', 'pol-uoker', '666', 1, 0, 0),
  (424, 47679, 'Джордана Брюстер', 'dzhordana-bryuster', '666', 1, 0, 0),
  (425, 16059, 'Мэтт Шульце', 'mett-shulce', '666', 1, 0, 0),
  (426, 29366, 'Рик Юн', 'rik-yun', '666', 1, 0, 0),
  (427, 22695, 'Чэд Линдберг', 'ched-lindberg', '666', 1, 0, 0),
  (428, 47429, 'Джонни Стронг', 'dzhonni-strong', '666', 1, 0, 0),
  (429, 532, 'Тед Левайн', 'ted-levayn', '666', 1, 0, 0),
  (430, 7189, 'Том Бэрри', 'tom-berri', '666', 1, 0, 0),
  (431, 2409, 'Роб Коэн', 'rob-koen', '666', 0, 1, 0)
";



      foreach($tableSchema as $table) {

        $db->query($table);

      }

  echo $skin_header;


echo <<<HTML
<form action="index.php" method="get">
<div class="panel panel-default">
  <div class="panel-heading">
    Установка завершена
  </div>
  <div class="panel-body">
Поздравляем Вас, DataLife Engine был успешно установлен на Ваш сервер. Вы можете зайти теперь на главную <a href="index.php">страницу вашего сайта</a>  и посмотреть возможности скрипта. Либо Вы можете <a href="admin.php">зайти</a> в панель управления DataLife Engine и изменить другие настройки системы.
<br><br><span class="text-danger">Внимание: при установке скрипта создается структура базы данных, создается аккаунт администратора, а также прописываются основные настройки системы, поэтому после успешной установки удалите файл <b>install.php</b> во избежание повторной установки скрипта!</span><br><br>
Приятной Вам работы<br><br>
SoftNews Media Group
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Продолжить</button>
  </div>
</div>
</form>
HTML;

}
else {

	if (@file_exists(ENGINE_DIR.'/data/config.php')) {

		msgbox( "", "Установка скрипта автоматически заблокирована", "Внимание, на сервере обнаружена уже установленная копия DataLife Engine. Если вы хотите еще раз произвести установку скрипта, то вам необходимо вручную удалить файл <b>/engine/data/config.php</b>, используя FTP протокол." );

		die ();
	}

$_SESSION['dle_install'] = 1;

// ********************************************************************************
// Приветствие
// ********************************************************************************

  echo $skin_header;

echo <<<HTML
<form method="get" action="">
<input type="hidden" name="action" value="eula">
<div class="panel panel-default">
  <div class="panel-heading">
    Мастер установки DataLife Engine <b>«Seopirat.club»</b>
  </div>
  <div class="panel-body">
	Добро пожаловать в мастер установки DataLife Engine. Данный мастер поможет вам установить скрипт всего за несколько минут. Однако, не смотря на это, мы настоятельно рекомендуем Вам ознакомиться с документацией по работе со скриптом, а также по его установке, которая поставляется вместе со скриптом.<br><br>
	Прежде чем начать установку убедитесь, что все файлы дистрибутива загружены на сервер, а также выставлены необходимые права доступа для папок и файлов.<br><br>
	Обращаем Ваше внимание на то, что DataLife Engine поддерживает работу с ЧПУ, а для этого необходимо, чтобы был установлен модуль <b>mod_rewrite</b> и его использование было разрешено. Eсли вы хотите отключить эту возможность, то удалите файл <b>.htaccess</b> в корневой папке и в процессе установки скрипта отключите поддержку этой функции.<br><br>
	<span class="text-danger">Внимание: при установке скрипта создается структура базы данных, создается аккаунт администратора, а также прописываются основные настройки системы, поэтому после успешной установки удалите файл <b>install.php</b> во избежание повторной установки скрипта!</span><br><br>
	Приятной Вам работы,<br><br>
	SoftNews Media Group
  </div>
  <div class="panel-footer">
	<button type="submit" class="btn bg-teal btn-sm btn-raised position-left"><i class="fa fa-arrow-circle-o-right position-left"></i>Начать установку</button>
  </div>
</div>
</form>
HTML;
}


echo $skin_footer;
?>